/*  wx_sine version 1.0

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

var lsin=new Array()
var lcos=new Array()
for (var i=0; i<513; i+=1) {
	lsin[i]=Math.sin( ((i/180)*Math.PI)/512*360)*1024
	lcos[i]=Math.cos( ((i/180)*Math.PI)/512*360)*1024
}

function wx_sine(x,y,w,h){
	this.id = "wx_sine"+(wx_sine.Count++);
	this.object = this.id + "Object";
		eval(this.object + "=this");

	this.ilayers = new Array()
	this.isindex = new Array()
	this.isindey = new Array()

	this.moveTo(x||0,y||0)
	this.setSize(w||320,h||320)
	this.setVisible(false)
	this.setBgColor('#000000')

	this.difx=this.w>>1
	this.dify=this.h>>1
	this.ampx=(this.w>>1)-40
	this.ampy=(this.h>>1)-60

	this.speedX=4
	this.speedY=2
	
	return this
}
wx_sine.Count=0
wx_sine.prototype = new DynLayer
wx_sine.prototype.timerid=null
wx_sine.prototype.running=false
wx_sine.prototype.itemcount=0
wx_sine.prototype.getSubClass = function() { return wx_sine }
wx_sine.prototype.add=function(src,w,h) {
		i=this.ilayers.length
		this.ilayers[i]=new DynLayer()
		this.ilayers[i].setVisible(true)
		this.ilayers[i].setSize(w||32,h||32)
		this.ilayers[i].setHTML('<img src="'+src+'" width=32 height=32>')
		this.isindex[i]=i<<4
		this.isindey[i]=i<<4
		this.addChild(this.ilayers[i])
		this.itemcount=this.ilayers.length
	}
wx_sine.prototype.update=function(){
	for (var i=0; i<this.itemcount; i++) {
		this.ilayers[i].moveTo(this.difx+((lsin[this.isindex[i]]*this.ampx)>>10),this.dify+((lcos[this.isindey[i]]*this.ampy)>>10))
		this.isindex[i]+=this.speedX; if (this.isindex[i]>511) this.isindex[i]-=512
		this.isindey[i]+=this.speedY; if (this.isindey[i]>511) this.isindey[i]-=512
	}
	
	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
}
wx_sine.prototype.setAmpX=function(val) { this.ampx=val }
wx_sine.prototype.setAmpY=function(val) { this.ampy=val }
wx_sine.prototype.changeAmpX=function(val) { this.ampx+=val; if (this.ampx<0) this.ampx=0}
wx_sine.prototype.changeAmpY=function(val) { this.ampy+=val; if (this.ampy<0) this.ampy=0 }
wx_sine.prototype.setDifX=function(val) { this.difx=val }
wx_sine.prototype.setDifY=function(val) { this.dify=val }
wx_sine.prototype.changeDifX=function(val) { this.difx+=val }
wx_sine.prototype.changeDifY=function(val) { this.dify+=val }
wx_sine.prototype.setSpeedX=function(val) { this.speedX=val }
wx_sine.prototype.setSpeedY=function(val) { this.speedY=val }
wx_sine.prototype.changeSpeedX=function(val) { this.speedX+=val; if (this.speedX<0) this.speedX=0 }
wx_sine.prototype.changeSpeedY=function(val) { this.speedY+=val; if (this.speedY<0) this.speedY=0 }
wx_sine.prototype.start = function () { 
	this.stop()

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
	else this.timerid = setInterval(this.object+'.update()',25) 
	this.running=true
}
wx_sine.prototype.stop = function () { 
	if(this.running)
		if (is.ns) clearTimeout(this.timerid)
		else clearInterval(this.timerid)
	this.running = false
}
wx_sine.prototype.remove=function() { this.deleteFromParent() }