// DynLayer Slide Methods
// straight line animation methods
// 2000.03.13

// Copyright (C) 1999 Dan Steinman
// Distributed under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

DynLayer.prototype.slideTo = function (endx,endy,inc,speed) {
	if (endx==null) endx = this.x
	if (endy==null) endy = this.y
	var distx = endx-this.x
	var disty = endy-this.y
	this.slideStart(endx,endy,distx,disty,inc,speed)
}
DynLayer.prototype.slideBy = function (distx,disty,inc,speed) {
	if (distx==null) distx = 0
	if (disty==null) disty = 0
	var endx = this.x+distx
	var endy = this.y+disty
	this.slideStart(endx,endy,distx,disty,inc,speed,fn)
}
DynLayer.prototype.slideStart = function (endx,endy,distx,disty,inc,speed) {
	if (this.slideActive) return
	if (!inc) inc = 10
	if (!speed) speed = 20
	this.slideN = Math.floor(Math.sqrt(Math.pow(distx,2) + Math.pow(disty,2))/inc)
	if (this.slideN==0) return
	this.slideEndX = endx
	this.slideEndY = endy
	this.slideDX = distx/this.slideN
	this.slideDY = disty/this.slideN
	this.slideActive = true
	this.slideI = 0
	this.slideInterval = setInterval(this+".slide()",speed)
}
DynLayer.prototype.slide = function () {
	if (!this.slideActive) {
		clearInterval(this.slideInterval)
		this.slideActive = false
	}
	else if (this.slideI++ < this.slideN) {
		this.moveBy(this.slideDX,this.slideDY)
		this.invokeEvent("slide")
	}
	else {
		this.moveTo(this.slideEndX,this.slideEndY)
		this.invokeEvent("slide")
		this.invokeEvent("slideend")
		this.slideActive = false
		clearInterval(this.slideInterval)
	}
}
