// *******************************************
// ** System Debugging Definitions:
// *******************************************
// *******************************************
// **
// ** Author: Brandon E. Myers
// **   Date: I don't know. Umm.. today? 01/10/1998
// ** E-Mail: Brandon_Myers@hotmail.com
// **
// *******************************************
// **
// ** Permission to use this Script is granted provided that
// ** you leave this file fully intact and this disclaimer
// ** is included on any and all pages which use any of the
// ** functions below. Also send an E-mail to me to let me know
// ** that my time was not wasted, and maybe I'll have an updated
// ** version with a lot of nifty new features.
// **
// *******************************************
// **
// ** Requires: Debugging HTML pages.
// **
// **
// *******************************************
// ** 
// ** Javascripts to enable real-time, inpage debugging.
// **
// *******************************************

// Debug flags:

var n = (document.layers) ? 1:0;
var ie = (document.all) ? 1:0;

if (typeof(window.top.debug)!='undefined') self.debug=window.top.debug;
else 
if (typeof(self.debug)=='undefined') self.debug=window.top.debug=new Object();
else window.top.debug=self.debug;

debug.METHOD=1;   // Prints in messages frame when an objects method is called.
debug.EVENT=2;   // Prints in messages frame when events are triggered.
debug.CONSTRUCT=4; // Prints in messages frame when an object is created.
debug.ENABLE_DEBUG_WINDOW=8; // Enable Debugging.
debug.GENERAL=16; // For Printing general messages.
debug.HIGH_PRIORITY=32;
debug.ALL=debug.METHOD|debug.EVENT|debug.CONSTRUCT|debug.GENERAL|debug.HIGH_PRIORITY;

debug.Debug=debug.HIGH_PRIORITY;

debug.ready=false;
debug.debugFrameset='/debug/index.html'; // For debugging.
debug.seqID=0; // Used to help place an order to the sequence.

function enableDebugging() {
    if (n) { 
//        aWindow=self.open=("javascript:","aWindow");
//        setTimeout('aWindow.close()',500);
    }
    debug.doEval=__configDoEval;
    debug.Debug=debug.Debug|debug.ENABLE_DEBUG_WINDOW;
    debug.dWindow=self.open(debug.debugFrameset,"__Debug__","width=640,height=350,toolbar=0,status=1,location=0,directories=0,menubar=0,scrollbars=0,resizable=1");
    debug.log('Debug Ready.',debug.HIGH_PRIORITY);
}
debug.enableDebug=enableDebugging;

function __describe(obj) {
    if (typeof(obj)!='object') return;
    if (debug.Debug&debug.ENABLE_DEBUG_WINDOW) 
        debug.dWindow.describe(obj);
}
debug.describe=__describe;

function __debugClose() {
	if (debug.Debug&debug.ENABLE_DEBUG_WINDOW) {
        debug.ready=false;
        debug.dWindow.winobj.closeDebug();
        debug.dWindow='';
        debug.Debug=debug.Debug^debug.ENABLE_DEBUG_WINDOW;
    }
    return true;
}
debug.debugClose=__debugClose;
debug.closeDebug=__debugClose;
debug.disableDebug=__debugClose;

function _escQuote(str) { // \042 is "  \047 is '
    var a=0;
    while(str.indexOf("'")>0 && a<300) {
        a++;
        str=str.substring(0,str.indexOf("'"))+'\\047'+str.substring(str.indexOf("'")+1,str.length);
    }
    a=0;
    while(str.indexOf('"')>0 && a<300) {
        a++;
        str=str.substring(0,str.indexOf('"'))+'\\042'+str.substring(str.indexOf('"')+1,str.length);
    }
    return str;
}

function __configDoEval(strVal,isWatch) {
    var vall='';
    isWatch=(typeof(isWatch)=='undefined'?false:isWatch);
    if (!isWatch) vall='<A HREF="#" onClick="parent.Command.document.ACCESS.evalue.value=\''+_escQuote(strVal)+'\';return false;" onMouseover="window.status=\''+_escQuote(strVal)+'\'">'
    vall=vall+ eval(strVal)
    if (!isWatch) vall=vall+'</a>\n';
    //alert(vall);
    return vall; //'<A HREF="#" onClick="parent.Command.document.ACCESS.evalue.value=\''+_escQuote(strVal)+'\';return false;" onMouseover="window.status=\''+_escQuote(strVal)+'\'>'+ eval(strVal)+'</a>';
}

function __configDoSet(strVar,strVal) {
	eval(strVar+'='+strVal);
}
debug.doSet=__configDoSet;

debug.saveRef=new Array();
debug.saveMesg=new Array();
debug.timeoutId=0;
debug.timeoutCount=0;

function _logRecover() {
    if (!debug.ready) {
        debug.timeoutCount++;
        debug.timeoutId=setTimeout('_logRecover();',200);
        return;
    }
    else {
        if (debug.timeoutId!=0) {
            debug.timeoutId=0;
            debug.log('Debug log buffer flushed.',debug.HIGH_PRIORITY);
        }
        debug.dWindow.winobj.write("Variables","\n");
    }
}

function __doDebug(mesg,DEBUG_TYPE,obj) {
    debug.lastMesg=mesg;
    if (typeof(DEBUG_TYPE)=='undefined') DEBUG_TYPE=debug.ALL;
    debug.lastType=DEBUG_TYPE;
    debug.lastObj=(typeof(obj)!='undefined')?obj:'';
	if (debug.Debug&debug.ENABLE_DEBUG_WINDOW)
		if (((debug.Debug&DEBUG_TYPE)|(DEBUG_TYPE&debug.HIGH_PRIORITY))!=0)
			if (!debug.ready) {
                debug.saveMesg[debug.saveMesg.length]="("+(this.seqID++)+")"+mesg;
            	debug.saveRef[debug.saveRef.length]=debug.lastObj;
                if (debug.timeoutId==0) {
                    debug.timeoutId=setTimeout('_logRecover();',200);
                    debug.timeoutCount++;
                }
            } else {
                if (debug.saveMesg.length!=0) {
                    debug.timeoutId=0;
                    for (i=0;i<debug.saveMesg.length;i++) {
                        if (typeof(debug.saveRef[i])=='object') {
                            debug.dWindow.winobj.write("Messages",debug.saveMesg[i],debug.saveRef[i]);
                        }
                        else debug.dWindow.winobj.write("Messages",debug.saveMesg[i]);
                    }
                    debug.dWindow.winobj.write("Messages","Debug Flush Complete.\n");
                    debug.saveRef=new Array();
                    debug.saveMesg=new Array();
                    return;
                }
                if (typeof(obj)!='undefined') {
                    debug.dWindow.winobj.write("Messages","("+(this.seqID++)+")"+mesg,obj);
                }
                else
                    debug.dWindow.winobj.write("Messages","("+(this.seqID++)+")"+mesg);
            }
}
debug.log=__doDebug;

function _funcname(f) {
    var s=f.toString().match(/function (\w*)/)[1];
    if ((s==null) || s.length==0) return "anonymous";
    return s;
}
debug.funcname=_funcname;

function __stacktrace() {
    var s="";
    for (var a=arguments.caller;a!=null;a=a.caller) {
        s+=this.funcname(a.callee)+'\n';
        if (a.caller==a) break;
    }
    return s;
}
debug.trace=__stacktrace;