/* DynAPI 2 (pre release 2)
   DHTML API which provides the core functionality needed in most DHTML applications
   2000.06.10

   Copyright (C) 2000 Dan Steinman
   Thanks to: 
        Micah Goulart, Chris Bodar, Pascal Bestebroer, Brandon Myers
        Bill Tammen, Scott Andrew, Robert Rainwater, Ryan Grenz
        Clark Pacheco, IlMaestro
   Redistributable under the terms of the GNU Library General Public License
   Available at http://www.dansteinman.com/dynapi/

 to do:
 - test updated dyndoc, make one for another window and see if you can control it
 - DynDoc.recreateAll() is need to recreate all the layers if the browser is resized in NN4
 - DOM Support.  (50%) So far layers can be created, positioned, resized, and set content.
     Working on NN6 events.

 ideas:
 - move DynAPI.removeFromArray code to Array.prototype.remove so that it can be used in all arrays

*************************************************************
Current Active Core Developers:
    Dan Steinman
    Brandon Myers
    Pascal Bestebroer
    Ryan Grenz
*************************************************************
*/

DynAPI = {
	loaded : false,
	documents : [],
	loadimages : [],
	check : {i:0},

	toString : function() {
		return "DynAPI"
	},
	version : function() {
		return this.toString()+"2000.06.22 (pre.2)"
	},
	getDocument : function(elm) {
		// might not be needed anymore
		return DynAPI.document
	},
	resizeHandler : function() {
		/* needs fixing
		var w = DynAPI.document.getWidth()
		var h = DynAPI.document.getHeight()
		DynAPI.document.findDimensions()
		if (is.ns4 && (w!=DynAPI.document.getWidth() || h!=DynAPI.document.getHeight())) {
			DynAPI.document.recreateAll()
		}
		*/
		DynAPI.document.invokeEvent("resize");
		if (DynAPI.onResize)
		    DynAPI.onResize()
	},
	loadHandler : function() {
        if (!DynAPI.document)
            self.location.href=self.location.href;
    	DynAPI.findLayers(DynAPI.document)
    	DynAPI.document.captureMouseEvents()
    	DynAPI.loaded = false;
    	DynAPI.document.invokeEvent('beforeload');
    	DynAPI.document.invokeEvent('load');
    	if (DynAPI.onLoad) DynAPI.onLoad()
    	DynAPI.loaded = true
    	DynAPI.document.invokeEvent('afterload');
    	DynAPI.loaderstart()
	},
	findLayers : function(dyndoc) {
	    var divs=[];
	 	if (is.ns4) divs = dyndoc.doc.layers
 		if (is.dom) divs = dyndoc.doc.getElementsByTagName("DIV")
	 	if (is.ie) divs = dyndoc.doc.all.tags("DIV")

	 	for (var i=0; i<divs.length; i++) {
	 		var id = is.ns4? divs[i].name : divs[i].id
			var dlyr = new DynLayer(id)
			dlyr.parent = dyndoc
			dlyr.assignElement(divs[i])
			
			if (dyndoc.getClass()!=DynDocument) dlyr.isChild = true
			dyndoc.children[dyndoc.children.length] = dlyr
			
	 		var index = id.indexOf("Div")
	 		if (index>0) self[id.substr(0,index)] = DynAPI.document.all[id]
			
			dlyr.updateValues()
			
	 		//if (is.ns4 && dlyr.doc.layers.length>0) DynLayer.check[DynLayer.check.length] = dlyr
	 	}
//		if (DynAPI.check.i < DynAPI.length) {
//			DynAPI.init(DynLayer.check[DynLayer.check.i++])
//		}
	},
	// how about Array.prototype.remove() instead ?
	removeFromArray : function(array, index, id) {
		var which = typeof index == "object" ? index : array[index]
		for (var i = 0; i < array.length; i++) {
			if (array[i] == which) {
				for(var x = i; x < array.length - 1; x++) 
					array[x] = array[x + 1]
				if (id) delete array[array[i].id]
				delete array[array.length - 1]
				break 
			}
		}
		array.length -= 1;
		return array
	}
}
//DynAPI=new DynAPIBase();

//	onResize : function(){},
//	onLoad : function(){}

function BrowserCheck() {
	var b = navigator.appName
	if (b=="Netscape") this.b = "ns"
	else if (b=="Microsoft Internet Explorer") this.b = "ie"
	else this.b = b
	this.version = navigator.appVersion
	this.v = parseInt(this.version)
	this.ns = (this.b=="ns" && this.v>=4)
	this.ns4 = (this.b=="ns" && this.v==4)
	this.ns5 = (this.b=="ns" && this.v==5)
	this.ie = (this.b=="ie" && this.v>=4)
	this.ie4 = (this.version.indexOf('MSIE 4')>0)
	this.ie5 = (this.version.indexOf('MSIE 5')>0)
	
	// Detect as close to TRUE DOM as possible... DOM support in this API is dependent on the following 2 functions.
	this.dom = (!this.ns4 && (document.createRange&&(document.createRange().createContextualFragment))?true:false)
	
	this.min = (this.ns||this.ie)
	var ua = navigator.userAgent.toLowerCase()
	if (ua.indexOf("win")>-1) this.platform = "win32"
	else if (ua.indexOf("mac")>-1) this.platform = "mac"
	else this.platform = "other"
}
is = DynAPI.browser = new BrowserCheck()

onload = DynAPI.loadHandler
onresize = DynAPI.resizeHandler

DynAPI.dimension=function(x,y,w,h,s) {
    this.x=x;
    this.y=y;
    this.w=w;
    this.h=h;
    this.source=s||null;
}
DynLayer.prototype.setMaxSize=function(p,noev) {
    if (!this.created && !p) return; // don't do anything if it's not created and we don't specift a containing layer.
    var w=h=0;
    if (this.created) {
        if (is.ns5) {
            w=this.dyndoc.doc.body.style.width;
            h=this.dyndoc.doc.body.style.height;
        } else {
            w=(is.ns4?this.doc.width:parseInt(this.elm.scrollWidth));
            h=(is.ns4?this.doc.height:parseInt(this.elm.scrollHeight));
        }
    }
    if (typeof(p)=='object') {
        if (p==DynAPI.document && is.ns5) {
            w=DynAPI.document.doc.width;
            h=DynAPI.document.doc.height;
        } else {
            w=(w>p.w?w:p.w);
            h=(h>p.h?h:p.h);
        }
    } else if (typeof(p)=='boolean') noevt=p;
    this.setSize(w,h,noev);
}

DynLayer.prototype.setPadding=function(p) {
    this.pad=p;
    if (this.created) {
        if (is.ie || is.ns5) this.elm.style.padding=p;
        else if (is.ns4) this.elm.padding=p;
    }
}
DynLayer.prototype.getPadding=function() {
    return this.pad;
}
DynAPI.wasDraging = false; // needed for dragging code fix.

//DynAPI.loadimages=new Array()
//
DynAPI.getImage = function(src,w,h) {
    var i;
	for (var i=0; i<DynAPI.loadimages.length; i++) 
	    if (DynAPI.loadimages[i].img.src==src)
	        return DynAPI.loadimages[i].img;
	if (src!='') {
		var l =DynAPI.loadimages.length
		DynAPI.loadimages[l] = {img:new Image(w||0,h||0),complete:false}
//		DynAPI.loadimages[l] = new Image(w||0,h||0)
		DynAPI.loadimages[l].img.src = src
		DynAPI.loadimages[l].img.w = DynAPI.loadimages[l].img.width
		DynAPI.loadimages[l].img.h = DynAPI.loadimages[l].img.height
//		DynAPI.loadimages[l].complete=false;
		return DynAPI.loadimages[l].img
	}
}
/*
DynAPI.getImage = function(src,w,h) {
	for (var i=0; i<DynAPI.loadimages.length; i++) if (DynAPI.loadimages[i].src==src) src=''
	if (src!='') {
		var i =DynAPI.loadimages.length
		DynAPI.loadimages[i] = new Image(w||0,h||0)
		DynAPI.loadimages[i].src = src
		DynAPI.loadimages[i].w = DynAPI.loadimages[i].width
		DynAPI.loadimages[i].h = DynAPI.loadimages[i].height
		return DynAPI.loadimages[i]
	} else {
		for (var i=0; i<DynAPI.loadimages.length; i++) if (DynAPI.loadimages[i].src==src) img=DynAPI.loadimages[i]
		return img
	}
}
*/
DynAPI.loaderstart=function() { 
	DynAPI.timerId=setTimeout('DynAPI.loadercheck()',50) 
	if (DynAPI.onLoaderStart) DynAPI.onLoaderStart()
}
DynAPI.loadercheck=function() {
	DynAPI.ItemsDone=0
	
	var max=DynAPI.loadimages.length-1
	for (var i=0; i<max; i++) 
	    if (DynAPI.loadimages[i].complete) 
	        DynAPI.ItemsDone+=1

	if (DynAPI.ItemsDone<max) {
		if (DynAPI.onLoading) DynAPI.onLoading()
		DynAPI.timerId=setTimeout(DynAPI+'.loadercheck()',25)
	} else if (DynAPI.onLoaderDone) DynAPI.onLoaderDone()
}

//DynAPI.onLoaderStart=function() {}
//DynAPI.onLoaderDone=function() {}
//DynAPI.onLoading=function() {}

function DynLayer() {
	this.elm = {}
	this.doc = {}
	this.css = {}
	var a = arguments
	if (a.length==1 && a[0]!=null && typeof(a[0])=="object") this.setStyle(a[0])
	else {
		this.id = "JSDynLayer"+(DynLayer.nullCount++) //a[0]||
		this.x = a[1]||0
		this.y = a[2]||0
		this.w = a[3]||null
		this.h = a[4]||null
		this.bgColor = a[5]||null
		this.visible = a[6]!='hidden'
		this.z = a[7]||0
		this.bgImage=null
		// not necessary to supply the document in the constructor, that is now set in addChild()
		// this.dyndoc = a[8]||DynAPI.document
	}
	this.children = []
	this.parent = null
	this.isChild = false
	this.created = false
	this.html=null
	this.bgImage=null
	
	// CODE NEEDED: need to make a DynAPI.temp[] collection to assign to
	// when you addChild() it will create in that document, and remove from the temp[]
	DynAPI.document.all[DynAPI.document.all.length] = this 
	DynAPI.document.all[this.id] = this
}
DynLayer.nullCount = 0
DynLayer.prototype.getComponent = function () {return this}
DynLayer.prototype.setParentComponent = function (par) {this.parentComponent = par}
DynLayer.prototype.getParentComponent = function () {return this.parentComponent}
DynLayer.prototype.getClass = function() {return this.constructor}
DynLayer.prototype.toString = function () {return 'DynAPI.document.all.'+this.id}
DynLayer.prototype.addChild = function() {
	for (var a=0;a<arguments.length;a++) {
		var child = arguments[a].getComponent()
		if (child.created) child.removeFromParent()
		child.isChild = true
		child.parent = this
		child.dyndoc = this.dyndoc
		this.children[this.children.length] = child
		if (this.created) {
			child.createElement()
		}
	}
	return arguments[arguments.length-1]
}
DynLayer.prototype.removeChild = function() {
	for (var a=0;a<arguments.length;a++) {
		var child = arguments[a].getComponent()
		for (var i=0;i<this.children.length;i++) {
			if (this.children[i]==child) {
				DynAPI.removeFromArray(this.children, child, false)
								
				child.deleteElement()
				child.parent = null
				child.isChild = false

				break

			}
		}
	}
	return arguments[arguments.length-1]
}
DynLayer.prototype.removeFromParent = function() {
	if (this.parent!=null) this.parent.removeChild(this)
}
DynLayer.prototype.deleteChild = function(child) {
	for (var a=0;a<arguments.length;a++) {
		var child = arguments[a].getComponent()
		child.invokeEvent('delete'); // Std event structure.
		if (child.onDelete) child.onDelete(); // New Code : Pascal Bestebroer
		for (var i=0;i<this.children.length;i++) {
			if (this.children[i]==child) {

				if (is.ns4) {
				 	if (!this.doc.recycled) this.doc.recycled = []
				 	var r = this.doc.recycled
				 	r[r.length] = child.elm
				}
			
				child.deleteAllChildren()
				DynAPI.removeFromArray(this.children, child, false) // New Code : DHTML Fiend : Updated Array handling
				DynAPI.removeFromArray(this.dyndoc.all, child, true) // New Code : DHTML Fiend : Updated Array handling
				if (is.ns4) {
					child.doc.open()
					child.doc.write('')
					child.doc.close()
				}
				child.deleteElement()
				child.parent = null
				child.isChild = false
				break
			}
		}
	}
}
DynLayer.prototype.deleteAllChildren = function() {
	for (var i in this.children) {
		this.children[i].created = false
		this.children[i].parent = null
		this.children[i].isChild = false
		this.children[i].invokeEvent('delete'); // New Code : Pascal Bestebroer
		if (this.children[i].onDelete) this.children[i].onDelete() // New Code : Pascal Bestebroer
		this.children[i].deleteAllChildren()
		DynAPI.removeFromArray(this.dyndoc.all, this.children[i], true)
	}
	this.children = []
}
DynLayer.prototype.deleteFromParent = function() {this.parent.deleteChild(this)}
DynLayer.prototype.createElement = function() {
	if (this.created || !this.parent || !this.parent.created) return
	
	var id = this.id
	var parent = this.parent
	var p = this.pad||0;
	var w = this.w	
	var lyr
	var doc = parent.doc

	if (doc.recycled && doc.recycled.length>0) {
		lyr = doc.recycled[0]
		DynAPI.removeFromArray(doc.recycled,doc.recycled[0],false)
	}
	else {
		var parentElement = (parent.getClass()==DynLayer)? parent.elm : parent.doc.body
		if (is.ns4) {
//			this.dyndoc.elm.eval("lyr = new Layer(w,parent.elm)")
			lyr = new Layer(w,parent.elm);
			lyr.captureEvents(Event.LOAD);
			lyr.onload=function() {} // netscape requires this.
			lyr.padding=p;
		}
		else if (is.ie4) {
			var code = '<div id="' + id + '" style="position:absolute; left:0px; top:0px; padding:'+p+'px; width:'+w+'px;"></div>'
			parentElement.insertAdjacentHTML("beforeEnd", code)
			lyr = parentElement.children[parentElement.children.length-1]
		}
		else if (is.dom) { // DOM support (NOT JUST NS5)
			lyr = this.dyndoc.doc.createElement("DIV");
			lyr.setAttribute("style","position:absolute; left:0px; top:0px; padding:"+(p||0)+"px; width:"+(w||0)+"px;");
			lyr.setAttribute("id",id);
			parentElement.appendChild(lyr);
		}
		else if (is.ie5) {
			lyr = this.dyndoc.doc.createElement("DIV")
			lyr.style.position = "absolute"
			lyr.style.width = w||0
			lyr.style.padding=p
			lyr.id=id
			parentElement.appendChild(lyr)
		}
	}
	this.assignElement(lyr)

	this.moveTo(this.x,this.y)
	this.setSize(this.w,this.h)
	this.setBgColor(this.bgColor)
	if (this.bgImage!=null) this.setBgImage(this.bgImage)
	if (this.hasEventListeners) this.captureMouseEvents()
	if (this.html!=null) {
		this.setHTML(this.html)
		if (this.w==null) this.w = this.getContentWidth()
		if (this.h==null) this.h = this.getContentHeight()
		this.setSize(this.w,this.h,false)
	}
	if (this.clip) this.setClip(this.clip)
	if (this.z) this.setZIndex(this.z)
	this.setVisible(this.visible)
	this.createChildElements()
	this.invokeEvent('create'); // Need to start moving things to the event structure.
	
	if (this.onCreate) this.onCreate() // Left here for backward compatability.
}
DynLayer.prototype.assignElement = function(elm) {
	this.elm = elm
	if (is.ns4) {			
		this.css = this.elm
		this.doc = this.elm.document
		this.doc.lyrobj = this
	}
	else if (is.ie || is.dom) {
		this.css = this.elm.style
		var b=true;
//		for (i in this.css) {if (!b) break;b=confirm(i+":"+this.css[i]);}
		this.doc = this.parent.doc
	}
	this.elm.lyrobj = this
	this.created = true
}
DynLayer.prototype.updateValues = function() {
	if (is.ns) {
		this.x = parseInt(this.css.left)
		this.y = parseInt(this.css.top)
		this.w = is.ns4? this.css.clip.width : parseInt(this.css.width)
		this.h = is.ns4? this.css.clip.height : parseInt(this.css.height)
		if (is.ns4) {
			this.clip = [this.css.clip.top,this.css.clip.right,this.css.clip.bottom,this.css.clip.left]
		}
	}
	else if (is.ie) {
		this.x = this.elm.offsetLeft
		this.y = this.elm.offsetTop
		this.w = is.ie4? this.css.pixelWidth : this.elm.offsetWidth
		this.h = is.ie4? this.css.pixelHeight : this.elm.offsetHeight
	}
}
DynLayer.prototype.createChildElements = function() {
	for (var i in this.children) {
		this.children[i].dyndoc = this.dyndoc
		this.children[i].createElement()
	}
}
DynLayer.prototype.deleteElement = function() {
	this.created = false
	if (is.ns4) {
	    this.elm.visibility="hide"
		this.elm.releaseEvents(Event.LOAD);
	} else {
		this.elm.style.visibility="hidden"
		if (is.dom) {// NS5 supports inner and outer HTML with the extensions.
		    if (!is.ns5) this.elm.parentNode.removeChild(this.elm)
		} else
        if (this.elm.children.length>0) {
           this.elm.removeNode(true);
        }
		this.elm.innerHTML="" // in NN5 this will empty out the elmement.
		this.elm.outterHTML=""
	}
	this.elm = {}
	this.doc = {}
	this.css = {}
	this.deleteChildElements()
}
DynLayer.prototype.deleteChildElements = function() {
	for (var i in this.children) {
		this.children[i].deleteElement()
	}
}

DynLayer.prototype.setStyle = function (s) {
	var id=s.id,x=s.left,y=s.top,w=s.width,h=s.height,i=s.backgroundImage,c=s.backgroundColor,v=s.visibility,z=s.zIndex
	if (!this.id && !this.created) this.id = id||"JSDynLayer"+(DynLayer.nullCount++)
	if (x!=null||y!=null) this.moveTo(x,y)
	if (w!=null||h!=null) this.setSize(w,h)
	if (i!=null) this.setBgImage(i)
	if (c!=null) this.setBgColor(c)
	if (z!=null) this.setZIndex(z)
	this.setVisible(v!='hidden')
}
DynLayer.prototype.moveTo = function(x,y) {
	if (x!=null) {
		this.x = x
		if (is.ns) this.css.left = this.x
		else this.css.pixelLeft = this.x
		//if (x) alert(this.css.left)
	}
	if (y!=null) {
		this.y = y
		if (is.ns) this.css.top = this.y
		else this.css.pixelTop = this.y
	}
	this.invokeEvent('move')
}
DynLayer.prototype.moveBy = function(x,y) {this.moveTo(this.x+x,this.y+y)}
DynLayer.prototype.setX = function(x) {this.moveTo(x,null)}
DynLayer.prototype.setY = function(y) {this.moveTo(null,y)}
DynLayer.prototype.getX = function() {return this.x}
DynLayer.prototype.getY = function() {return this.y}
DynLayer.prototype.getPageX = function() {
	if (!this.created) return 0
	if (is.ns4) return this.css.pageX
	else return (this.isChild)? this.parent.getPageX()+this.x : this.x
}
DynLayer.prototype.getPageY = function() {
	if (!this.created) return 0
	if (is.ns4) return this.css.pageY
	else return (this.isChild)? this.parent.getPageY()+this.y : this.y
}
DynLayer.prototype.setPageX = function(x) {
	if (is.ns4) this.css.pageX = x
	if (is.ie) {
		if (this.isChild) this.setX(this.parent.getPageX()-x)
		else this.setX(x)
	}
	this.getX()
	this.invokeEvent('move')
}
DynLayer.prototype.setPageY = function(y) {
	if (is.ns4) this.css.pageY = y
	if (is.ie) {
		if (this.isChild) this.setY(this.parent.getPageY()-y)
		else this.setY(y)
	}
	this.getY()
	this.invokeEvent('move')
}
DynLayer.prototype.setVisible = function(b) {
	this.visible = b
	this.css.visibility=b?"inherit":(is.ns4?"hide":"hidden")
}
DynLayer.prototype.getVisible = function() {return this.visible}
DynLayer.prototype.setZIndex = function(z) {
	this.z = z
	this.css.zIndex = z
}
DynLayer.prototype.getZIndex = function() {return this.z}
DynLayer.prototype.setBgImage = function(path) {
	this.bgImage = path
	if (!this.created) return
	if (is.ns4) {
		this.elm.background.src = path
		if (!path) this.setBgColor(this.getBgColor())
	}
	else this.css.backgroundImage = 'url('+path+')'
}
DynLayer.prototype.getBgImage = function() {return this.bgImage}
DynLayer.prototype.setBgColor = function(color) {
	if (!is.ns4 && color==null) {
		color=''
	}
	this.bgColor = color
	if (is.ns4) this.doc.bgColor = color
	else this.css.backgroundColor = color
}
DynLayer.prototype.getBgColor = function(color) {return this.bgColor}

DynLayer.prototype.setHTML = function(html) {
	if (html==null) html = ''
	if (!this.created) {
		this.html = html
		return
	}
	this.invokeEvent("beforeload");
	if (is.ns4) {
		this.doc.open()
		this.doc.write(html)
		this.doc.close()
	}
	else if (is.dom) // Emulated innerHTML.
	    DOMShortcuts.setInnerHTML(this.elm,html);
	this.elm.innerHTML=html
	if (is.ns4)
	    for (i in this.doc.images) this.doc.images[i].lyrobj = this
	else if (is.dom) {
	    var images=this.elm.getElementsByTagName("img");
	    for (i in images) images[i].lyrobj = this;
	}
	else if (is.ie) 
	    for (i in this.elm.all.tags("img")) this.elm.all.tags("img")[i].lyrobj = this
	this.invokeEvent("load");
	this.invokeEvent("afterload");
}
DynLayer.prototype.getHTML = function() {
    if (this.created)
        if (is.dom)
            return DOMShortcuts.getInnerHTML(this.elm)
        else return this.elm.innerHTML;
    else
        return this.innerHTML
}
DynLayer.prototype.setSize = function(w,h,noevt) {
	this.setWidth(w,false)
	this.setHeight(h,false)
	if (!noevt) this.invokeEvent('resize');
}
DynLayer.prototype.setWidth = function(w,noevt) {
	if (w==null) w=this.w
	else w=this.w=(((w||this.w)||-1)<0?0:w);
	if (!this.created) return;

	if (is.ns) {
		this.css.clip.width = w
	}
	else if (is.ie || is.dom) {
		this.css.width = w;
		this.css.height = h;
		if (is.ie) this.setClip([0,w,this.h,0]);
	} 
	
	if (!noevt) this.invokeEvent('resize');
}

DynLayer.prototype.setHeight = function(h,noevt) {
	if (h==null) h=this.h
	else h=this.h=(((h||this.h)||-1)<0?0:h);
	if (!this.created) return;
	
	if (is.ns) {
		this.css.clip.height = h
	}
	else if (is.ie || is.dom) {
		this.css.width = w;
		this.css.height = h;
		if (is.ie) this.setClip([0,w,h,0]);
	} 
		
	if (!noevt) this.invokeEvent('resize');
}

DynLayer.prototype.getWidth = function() {return this.w}
DynLayer.prototype.getHeight = function() {return this.h}
DynLayer.prototype.getContentWidth = function() {return !this.created?0:(is.ns?this.doc.width:parseInt(this.elm.scrollWidth))}
DynLayer.prototype.getContentHeight = function() {return !this.created?0:(is.ns?this.doc.height:parseInt(this.elm.scrollHeight))}
DynLayer.prototype.setClip = function(clip) {
	if (!this.created) {
		this.clip = clip
		return
	}
	var cc = this.getClip()
	for (var i in clip) if (clip[i]==null) clip[i]=cc[i]
	var c = this.css.clip
	if (is.ns4) {
		c.top = clip[0]
		c.right = clip[1]
		c.bottom = clip[2]
		c.left = clip[3]
	}
	else if (is.ie) this.css.clip = "rect("+clip[0]+"px "+clip[1]+"px "+clip[2]+"px "+clip[3]+"px)"
}
DynLayer.prototype.getClip = function() {
	var c = this.css.clip
	if (c) {
		if (is.ns4) return [c.top,c.right,c.bottom,c.left]
		else {
			c = c.split("rect(")[1].split(")")[0].split("px")
			for (var i in c) c[i]=parseInt(c[i])
			return [c[0],c[1],c[2],c[3]]
		}
	}
	else return [0,0,0,0]
}
DynLayer.prototype.captureMouseEvents = function() {
	if (!this.eventListeners) this.eventListeners = []
	this.hasEventListeners = true
	if (!this.created) return
	var elm = this.elm
	if (is.ns4) elm.captureEvents(Event.MOUSEDOWN | Event.MOUSEUP | Event.CLICK | Event.DBLCLICK)
	elm.onmousedown = elm.onmouseup = elm.onmouseover = elm.onmouseout = elm.onclick = elm.ondblclick = function(e) {
		var dyndoc = this.lyrobj.dyndoc
		if (is.ie) {
			var e = dyndoc.elm.event
			e.cancelBubble = true
			if (e.type=="click" && DynAPI.wasDragging) {
			    e.cancelBubble=true;
			    DynAPI.wasDragging=false;
			    return true;
			}
			if (e.type!="mouseout" && e.type!="mouseover") e.cancelBubble = true
			if (e.type=="mouseout" && this.contains(e.toElement)) return true
			if (e.type=="mouseover" && this.contains(e.fromElement)) return true
		}
		var realsrc = is.ie ? e.srcElement : e.target
		var src = realsrc.lyrobj
		if (!src) {
			src = DynAPI.getDocument(realsrc)
			if (!src) return true
		}
		var evt = dyndoc._e // New Code : DHTML Fiend
		evt.setEvent(src,e)
		src.invokeEvent(e.type,evt)
		if (e.type=="mouseover" || e.type=="mouseout") return false
		else return evt.bubbleEvent()
	}
}
DynLayer.prototype.addEventListener = function(listener) {
	if (!this.hasEventListeners) this.captureMouseEvents()
	for (var i in this.eventListeners) {
		if (this.eventListeners[i]==listener) return
	}
	this.eventListeners[this.eventListeners.length] = listener
}
DynLayer.prototype.removeEventListener = function(listener) {
	DynAPI.removeFromArray(this.eventListeners, listener, false)
}
DynLayer.prototype.removeAllEventListeners = function() {
	if (!this.hasEventListeners) return
	for (var i in this.eventListeners) 
		delete this.eventListeners[i]
	this.eventListeners = []
}
DynLayer.prototype.invokeEvent = function(type,e) {
	if (!this.hasEventListeners) return
	var orig=null
	if (e && is.ns) { 
	    orig=e.orig; //Get the orig here...
		e.cancelBubble=false; // default not to cancel bubble. Events could change that.
    }
	if (is.ns4 && is.platform=="other") {
		if (type=="mousedown") {
			if (this.dbltimer!=null) type = "dblclick"
			else this.dbltimer = setTimeout(this+'.dbltimer=null',300)
		}
	}
	for (var i=0;i<this.eventListeners.length;i++) {
		if (e) e.target = this.eventListeners[i].target
		else {
			e = new DynEvent(type,this)
			e.target = this.eventListeners[i].target
    		if (is.ns) e.cancelBubble=false; // default not to cancel bubble. Events could change that.
		}
		this.eventListeners[i].handleEvent(type,e)
	}
    if (is.ns4 && e) {
        if (e.cancelBubble) return; // This way, we can stop the bubble in Netscpe.
        if (orig && orig.target.handleEvent && orig.target!= this.elm) {
    	    orig.target.handleEvent(orig);
    	}
    	//window.routeEvent(e);
    }
	if (is.ns4 && is.platform=="other" && type=="mouseup") this.invokeEvent("click",e)
	if (this.parentComponent) {
		if (e) e.src = this.parentComponent
		else {
			e = new DynEvent(type,this)
		}
		this.parentComponent.invokeEvent(type,e)
	}
}
//DynLayer.prototype.onCreate = new Function()
//DynLayer.prototype.onDelete = new Function()


DynEvent = function(type,src,target) {
	this.type = type
	this.src = src
	this.target = target
}
DynEvent.prototype.getType = function() {return this.type}
DynEvent.prototype.getSource = function() {return this.src}
DynEvent.prototype.getTarget = function() {return this.target}

EventListener = function(target) {this.target = target}
EventListener.prototype.handleEvent = function(type,e) {
	if (typeof this["on"+type] !='undefined') {
	    this["on"+type](e)
	}
}

MouseEvent = function() {}
MouseEvent.prototype.getType = function() {return this.type}
MouseEvent.prototype.getSource = function() {return this.src}
MouseEvent.prototype.getTarget = function() {return this.target}
MouseEvent.prototype.setEvent = function(src,e) {
	this.bubble = true
	this.src = src
	this.type = e.type
	
	this.pageX = is.ie ? e.x + document.body.scrollLeft : e.pageX - window.pageXOffset
	this.pageY = is.ie ? e.y + document.body.scrollTop : e.pageY - window.pageYOffset
	
	this.x = is.ie? e.offsetX : e.layerX
	this.y = is.ie? e.offsetY : e.layerY
	this.orig=e;
}
MouseEvent.prototype.bubbleEvent = function() {
	if (!this.bubble || this.src.getClass()==DynDocument) return this.bubble
	this.x +=this.src.getX()
	this.y +=this.src.getY()
	if (this.src.getComponent().parent==null) return this.bubble; // Return if the element was removed before event was fired.
	this.src = this.src.getComponent().parent
	this.src.invokeEvent(this.type,this)
	return this.bubbleEvent()
}
MouseEvent.prototype.getX = function() {return this.x}
MouseEvent.prototype.getY = function() {return this.y}
MouseEvent.prototype.getPageX = function() {return this.pageX}
MouseEvent.prototype.getPageY = function() {return this.pageY}
MouseEvent.prototype.setBubble = function(b) {this.bubble=b}


function DynDocument(frame) {
	this.doc = frame.document
	if (is.dom)
	    if (!this.doc.body)
	        this.doc.body=this.doc.getElementsByTagName('body')[0];
	this.elm = frame
	this.elm.lyrobj = this // New Code : DHTML Fiend
	this.doc.lyrobj = this // New Code : DHTML Fiend : Nasty Hack
	this.all = []
	this.children = []
	this.id = frame.name||"DynDocument"+DynDocument.count++
	this.obj = this.id+"Object"
	this.dyndoc = this 
	this.fgColor = this.doc.fgColor||''
	this.bgColor = this.doc.bgColor||''
	window[this.obj]=this;
	//eval(this.obj+"=this")
	this._e = new MouseEvent();
	if (!frame.document.length) return this;
	DynAPI.documents[DynAPI.documents.length] = this // New Code : DHTML Fiend
	DynAPI.documents[this.id] = this  // New Code : DHTML Fiend
	return this;
}
DynDocument.count = 0
DynDocument.prototype.isChild = false
DynDocument.prototype.created = true
DynDocument.prototype.toString = function() {return this.obj}
DynDocument.prototype.getClass = DynLayer.prototype.getClass
DynDocument.prototype.getComponent = DynLayer.prototype.getComponent
DynDocument.prototype.addChild = DynLayer.prototype.addChild
DynDocument.prototype.removeChild = DynLayer.prototype.removeChild
DynDocument.prototype.deleteChild = DynLayer.prototype.deleteChild

DynDocument.prototype.recreateAll = function() {
	// needs fixing
	for (var i in this.children) {
		this.children[i].deleteElement()
	}
	for (var i in this.children) {
		this.children[i].createElement()
	}
}
DynDocument.prototype.getX = DynDocument.prototype.getY = DynDocument.prototype.getPageX = DynDocument.prototype.getPageY = function() {return 0}
DynDocument.prototype.getWidth = function() {if (!this.w) this.findDimensions(); return this.w}
DynDocument.prototype.getHeight = function() {if (!this.h) this.findDimensions(); return this.h}
DynDocument.prototype.findDimensions = function() {
	this.w = (is.ns4)? this.elm.innerWidth : this.doc.body.offsetWidth-20 // New Code : DHTML Fiend
	this.h = (is.ns4)? this.elm.innerHeight : this.doc.body.offsetHeight-4	// New Code : DHTML Fiend
}
DynDocument.prototype.setBgColor = function(color) {
	if (color==null) color = ''
	this.bgColor = color
	this.doc.bgColor = color
}
DynDocument.prototype.setFgColor = function(color) {
	if (color==null) color = ''
	this.fgColor = color
	this.doc.fgColor = color
}
// could be worked into LoadQueue
DynDocument.prototype.load = function(path) {
	this.doc.href = path
}
DynDocument.prototype.captureMouseEvents = function() {
	if (this.mouseEventsCaptured) return
	this.mouseEventsCaptured = true
	if (!this.eventListeners) this.eventListeners = []
	this.hasEventListeners = true
	if (is.ns4) this.doc.captureEvents(Event.MOUSEMOVE | Event.MOUSEDOWN | Event.MOUSEUP | Event.CLICK | Event.DBLCLICK)
	this.doc.onmousemove = this.doc.onmousedown = this.doc.onmouseup = this.doc.onclick = this.doc.ondblclick = function(e) {
		if (is.ie) {
			var e = this.lyrobj.elm.event // New Code : DHTML Fiend
			e.cancelBubble = true
			if (e.type!="mouseout" && e.type!="mouseover") e.cancelBubble = true
			if (e.type=="mouseout" && this.contains(e.toElement)) return true
			if (e.type=="mouseover" && this.contains(e.fromElement)) return true
		}
		var realsrc = is.ie ? e.srcElement : e.target
		var src = realsrc.lyrobj
		if (!src) {
			src = DynAPI.getDocument(realsrc)
			if (!src) return true
		}
		var evt = this.lyrobj._e
		evt.setEvent(src,e)
		src.invokeEvent(e.type,evt)
		if (is.ie && (e.type=="mouseover" || e.type=="mouseout")) return false
		return evt.bubbleEvent()
	}
}
DynDocument.prototype.addEventListener = DynLayer.prototype.addEventListener
DynDocument.prototype.removeEventListener = DynLayer.prototype.removeEventListener
DynDocument.prototype.removeAllEventListeners = DynLayer.prototype.removeAllEventListeners // New Code : DHTML Fiend
DynDocument.prototype.invokeEvent = function(type,e) {
	if (!this.hasEventListeners) return;
	var orig=null
	if (e && is.ns) { 
	    orig=e.orig; //Get the orig here...
		e.cancelBubble=false; // default not to cancel bubble. Events could change that.
    }
	if (is.ns4 && is.platform=="other") {
		if (type=="mousedown") {
			if (this.dbltimer!=null) type = "dblclick"
			else this.dbltimer = setTimeout(this+'.dbltimer=null',300)
		}
	}
	for (var i=0;i<this.eventListeners.length;i++) {
		if (e) e.target = this.eventListeners[i].target
		else {
			e = new DynEvent(type,this)
			e.target = this.eventListeners[i].target
    		if (is.ns) e.cancelBubble=false;
		}
		this.eventListeners[i].handleEvent(type,e)
	}
	if (i!=0 || e)
    if (is.ns) {
        if (e.cancelBubble) return; // This way, we can stop the bubble in Netscpe.
        if (orig && orig.target.handleEvent && !orig.target.URL)
    	    orig.target.handleEvent(orig);
    }
	if (is.ns4 && is.platform=="other" && type=="mouseup") this.invokeEvent("click",e)
}

DynAPI.document = new DynDocument(self);


// This script gives getter and setter methods to the innerHTML and outerHTML properties of the HTMLElement
// In NN5/6. This utilizes standerd DOM functions to perform this amazing feat.z

var emptyElements = {
  HR: true, BR: true, IMG: true, INPUT: true
};
var specialElements = {
  TEXTAREA: true
};

if (is.dom) {	
	DOMShortcuts={};
	DOMShortcuts.setInnerHTML=function (node,html) {
		while (node.hasChildNodes()) {
			node.removeChild(node.lastChild);
			node.innerHTMLInput = html;
			if (node.ownerDocument==null) return;
			
			var range = node.ownerDocument.createRange();
			range.setStartAfter(node);
			var docFrag = range.createContextualFragment(html);
			node.appendChild(docFrag);
		}
	}
	DOMShortcuts.getInnerHTML=function (node) {
		var html = '';
		if (node.childNodes==null) return '';
		for (var c = 0; c < node.childNodes.length; c++)
			html += getOuterHTML(node.childNodes[c]);
		return html;
	}
	DOMShortcuts.setOuterHTML=function (node,html) {
		node.outerHTMLInput = html;
		var range = node.ownerDocument.createRange();
		range.setStartBefore(node);
		var docFrag = range.createContextualFragment(html);
		node.parentNode.replaceChild(docFrag, node);
	}
	DOMShortcuts.getOuterHTML=function(node) {
		var html = '';
		if (node.nodeType == Node.ELEMENT_NODE) {
			html += '<';
			html += node.nodeName;
			if (!specialElements[node.nodeName]) {
				for (var a = 0; a < node.attributes.length; a++) {
					html += ' ' + node.attributes[a].nodeName.toUpperCase() + '="' + node.attributes[a].nodeValue + '"';
				}
				html += '>'; 
				if (!emptyElements[node.nodeName]) {
					html += node.innerHTML;
					html += '<\/' + node.nodeName + '>';
				}
			}
			else {
				if (node.nodeName == 'TEXTAREA') {
					for (var a = 0; a < node.attributes.length; a++) {
						var content = '';
						if (node.attributes[a].nodeName.toLowerCase() != 'value') {
							html += ' ' + node.attributes[a].nodeName.toUpperCase() + '="' + node.attributes[a].nodeValue + '"';
						}
						else {
							content = node.attributes[a].nodeValue;
						}
						html += '>'; 
						html += content;
						html += '<\/' + node.nodeName + '>';
					}
				}
				else if (node.nodeName == Node.TEXT_NODE) {
					html += node.nodeValue;
				}
				else if (node.nodeName == Node.COMMENT_NODE) {
					html += '<!' + '--' + node.nodeValue + '--' + '>';
				}
			}
		}
		return html;
	}
}

/* Removed in favor of strict DOM compliance. w/out JS1.5 goodies.
if (is.ns5) // Include JS1.5 functions that cause IE and NN4 to stop working.
    document.write('<script lnaguage="Javascript1.5" src="../js/dynapi_ns5.js"></'+'script>');
*/


// SuperClass, handles method overriding

function SuperClass(childClass,parentClassName) {
	var parentClass = window[parentClassName]
	
	if (!childClass.prototype.SuperClass) {
		childClass.prototype.SuperClass = {}
	}
	
	var csc = childClass.prototype.SuperClass[parentClassName] = {
		ClassName : parentClassName,
		child : childClass,
		callParentMethod : function(method,args) {
			this.obj['Super_'+this.ClassName+'_'+method](args[0],args[1],args[2],args[3])
		}
	}
	childClass.prototype.setSuper = function(obj) {
		for (var i in this.SuperClass) {
			this.SuperClass[i].obj = obj
			this[i] = this.SuperClass[i]
		}
	}
	
	var obj = 'SuperClass'+SuperClass.count++
	window[obj] = csc;

	for (var i in parentClass.prototype) {
		if (i=="SuperClass" || i=="Super" || i=="setSuper" || i.indexOf("Super_")>-1) {}
		else if (typeof(parentClass.prototype[i]) == "function") { // can do properties also if needed
			childClass.prototype['Super_'+parentClassName+'_'+i] = parentClass.prototype[i]
			csc[i] = new Function(obj+".callParentMethod('"+i+"',arguments)")
		}
	}
}
SuperClass.count = 0
