// ButtonImage Object
// a generic image toggle button widget
// 2000.03.11

// Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

function ButtonImage() {
	this.component = new DynLayer()
	this.component.setParentComponent(this)
	this.events = new EventListener(this)
	this.events.onmousedown = function (e) {
		var o = e.getTarget()
		if (o.checkbox) o.setSelected(!o.selected)
		e.setBubble(false)
	}
	this.events.onmouseover = function (e) {
		var o = e.getTarget()
		if (o.selected) o.change(o.selectedRoll)
		else o.change(o.defaultRoll)
		e.setBubble(false)
	}
	this.events.onmouseout = function (e) {
		var o = e.getTarget()
		if (o.selected) o.change(o.selectedImage)
		else o.change(o.defaultImage)
		e.setBubble(false)
	}
	this.component.addEventListener(this.events)
}

WidgetInterface.inherit(ButtonImage)

ButtonImage.prototype.checkbox = false
ButtonImage.prototype.setImages = function(defaultImage,defaultRoll,selectedImage,selectedRoll) {
	if (arguments.length==4) this.checkbox = true
	this.defaultImage = defaultImage
	this.defaultRoll = defaultRoll
	this.selectedImage = selectedImage
	this.selectedRoll = selectedRoll	
	this.component.setHTML('<img name="'+this.component.id+'Image" src="'+this.defaultImage.src+'" width='+this.defaultImage.w+' height='+this.defaultImage.h+'>')
	this.component.setSize(this.defaultImage.w,this.defaultImage.h)
}
ButtonImage.prototype.setSelected = function(b) {
    this.selected=b;
	if (this.selected) {
		this.change(this.selectedImage)
		this.invokeEvent("select")
	}
	else {
		this.change(this.defaultImage)
		this.invokeEvent("deselect")
	}
}
ButtonImage.prototype.change = function(img) {
	if (img) this.component.doc.images[this.component.id+"Image"].src = img.src
}

