// Label
// a widget for adding reflowable and styled text
// 2000.03.11

// Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

function Label(text,wrap) {	
	this.component = new DynLayer()
	this.component.setParentComponent(this)
	this.textlyr = this.component.addChild(new DynLayer())
	this.component.target = this
	this.component.onCreate = function() {
		var o = this.target
		if (o.component.w==0) {
			o.component.setSize(o.textlyr.w,o.textlyr.h)
			if (o.hasCover) o.coverlyr.setSize(o.textlyr.w,o.textlyr.h)
		}
		else o.setWidth(o.component.w)
		o.onCreate()
	}
	this.wrap = wrap
	this.setText(text)
}

WidgetInterface.inherit(Label)

Label.prototype.text = ''
Label.prototype.wrap = true
Label.prototype.padding = 0
Label.prototype.align = 'left'
Label.prototype.setText = function(text) {
	this.text = text
	var styled = '<font>'+this.text+'</font>'
	var width = this.wrap? 'width='+this.textlyr.w : ''
	var wrap = this.wrap? '':'nowrap'
	this.textFull = '<table '+width+' cellpadding='+this.padding+' cellspacing=0 border=0><td align="'+this.align+'" '+wrap+'>'+styled+'</td></table>'
	this.textlyr.setHTML(this.textFull)
	this.rewrap()
}
Label.prototype.getText = function() {return this.text}
Label.prototype.setWrap = function(wrap) {
	this.wrap = wrap
	this.rewrap()
}
Label.prototype.rewrap = function() {
	if (!this.heightSet) {
		if (this.getContentHeight()!=this.getHeight()) {
			this.setHeight(null)
		}
	}
}
Label.prototype.setPadding = function(p) {
	this.padding = p
	this.setText(this.text)
}
Label.prototype.setWidth = function(w) {
	if (w==null) {
		w = this.textlyr.getContentWidth()
	}
	this.textlyr.setWidth(w)
	this.setText(this.text)
	if (!this.heightSet) this.setHeight(null)
	this.component.setSize(w,this.h)
	if (this.hasCover) this.coverlyr.setSize(w,this.component.h)
	this.invokeEvent('resize')
}
Label.prototype.setHeight = function(h) {
	if (h==null) this.h = this.textlyr.getContentHeight()
	else {
		this.heightSet = true
		this.h = h
	}
	this.textlyr.setHeight(this.h)
	this.component.setHeight(this.h)
	this.invokeEvent('resize')
}
Label.prototype.setSize = function(w,h) {
	this.setWidth(w)
	this.setHeight(h)
}
Label.prototype.setAlignment = function(a) {
	this.align = a
}
Label.prototype.addCover = function() {
	if (this.hasCover) return
	this.hasCover = true
	this.coverlyr = this.component.addChild(new DynLayer('',0,0,this.component.w,this.component.h))
}
Label.prototype.onCreate = new Function()
