// Label2
// a widget for adding reflowable and styled text
// 2000.03.11

// Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

function Label2(text) {
	this.setSuper(this)
	
	this.wrap = false
	this.padding = 0
	this.align = 'left'
	
	this.textlyr = this.addChild(new DynLayer())
	this.textlyr.setBgColor('cyan')
	this.setText(text)
}
Label2.prototype = new DynLayer
SuperClass(Label2,"DynLayer")

Label2.prototype.onCreate = function() {
	if (this.w==null) {
		this.DynLayer.setSize(this.textlyr.w,this.textlyr.h)
		if (this.hasCover) this.coverlyr.setSize(this.textlyr.w,this.textlyr.h)
	}
	else {
		if (this.h==0 || this.h==null) {
			this.setHeight(null)
		}
	}
}

Label2.prototype.setText = function(text) {
	this.text = text
	var styled = '<font>'+this.text+'</font>'
	var width = this.wrap? 'width='+this.textlyr.w : ''
	var wrap = this.wrap? '':'nowrap'
	this.textFull = '<table '+width+' cellpadding='+this.padding+' cellspacing=0 border=0><td align="'+this.align+'" '+wrap+'>'+styled+'</td></table>'
	this.textlyr.setHTML(this.textFull)
	
	this.rewrap()
}
Label2.prototype.getText = function() {return this.text}
Label2.prototype.setWrap = function(wrap) {
	this.wrap = wrap
	this.rewrap()
}
Label2.prototype.rewrap = function() {
	if (!this.heightSet) {
		if (this.getContentHeight()!=this.getHeight()) {
			this.setHeight(null)
		}
	}
}
Label2.prototype.setWidth = function(w) {
	if (w==null) {
		w = this.textlyr.getContentWidth()
		this.widthSet = false
	}
	else {
		this.textlyr.setWidth(w)
		this.setText(this.text)
		this.widthSet = true
	}
	this.DynLayer.setWidth(w)
	
	if (!this.heightSet) {
		var h = this.textlyr.getContentHeight()
		this.textlyr.setHeight(h)
		this.DynLayer.setHeight(h)
	}
	
	if (this.hasCover) this.coverlyr.setSize(this.w,this.h)
}
Label2.prototype.setHeight = function(h) {
	if (h==null) {
		h = this.textlyr.getContentHeight()
		this.heightSet = false
	}
	else {
		this.heightSet = true
	}
	this.textlyr.setHeight(h)
	this.DynLayer.setHeight(h)

	if (this.hasCover) this.coverlyr.setSize(this.w,this.h)
	this.invokeEvent('resize')
}
Label2.prototype.setSize = function(w,h) {
	this.setWidth(w)
	this.setHeight(h)
}
Label2.prototype.setPadding = function(p) {
	this.padding = p
	this.setText(this.text)
}
Label2.prototype.setAlignment = function(a) {
	this.align = a
}
Label2.prototype.addCover = function() {
	if (this.hasCover) return
	this.hasCover = true
	this.coverlyr = this.addChild(new DynLayer('',0,0,this.w,this.h))
}
