// Creating a basic layer component using DynAPI2:



/** Used to connect 2 tree nodes with a vertical line, if it is > 1 node away */
function TreeLine() {
	this.component = new DynLayer()
	this.component.setParentComponent(this)
	this.image="../images/TreeImages/vertline.gif";
	this.setBgImage(this.image);
//	this.component.setHTML('<table width='+this.image.w+' height="100%" cellspacing=0 cellpadding=0 border=><tr height=100%><td width='+this.image.w+' background="'+this.image.src+'"></tr></td></table>');
	this.component.setSize(16,0);
	//this.setBgColor("blue");
}

WidgetInterface.inherit(TreeLine)

function TreeButtonImage(srcDir) {
	this.component = new DynLayer();
	this.component.setParentComponent(this);
	this.srcDir=srcDir;
	this.icon=DynAPI.getImage(srcDir+"/doc.gif",24,22);
	this.setImages(DynAPI.getImage(srcDir+"/ptopnnode.gif",16,22),DynAPI.getImage(srcDir+"/mtopnode.gif"),16,22);

	this.events = new EventListener(this)

	this.events.onclick = function (e) {
		var o = e.getTarget();
		o.setSelected(!o.selected);
		e.setBubble(false);
	}
	this.events.onmouseover = function (e) {
		var o = e.getTarget();
		if (o.selected) o.change(o.selectedRoll);
		else o.change(o.defaultRoll);
		e.setBubble(false);
	}
	this.events.onmouseout = function (e) {
		var o = e.getTarget();
		if (o.selected) o.change(o.selectedImage);
		else o.change(o.defaultImage);
		e.setBubble(false);
	}
	this.component.addEventListener(this.events);
}

WidgetInterface.inherit(TreeButtonImage);

TreeButtonImage.prototype.setImages = function(defaultImage,selectedImage) {
	this.defaultImage = defaultImage;
	this.selectedImage = selectedImage;
	this.component.setHTML('<table cellspacing=0 cellpadding=0 border=0 align=left><tr><td><img name="'+this.component.id+'Image" src="'+this.defaultImage.src+'" width='+this.defaultImage.w+' height='+this.defaultImage.h+'></td><td><img name="'+this.component.id+'Icon" src="'+this.icon.src+'" width='+this.icon.w+' height='+this.icon.h+'></td></tr></table>');
    this.component.setSize(this.defaultImage.w+this.icon.w,this.defaultImage.h);
}

/** For changing the image type on this tree node.. */
TreeButtonImage.prototype.changeDefaultImage=function(imageSrc) {
	this.defaultImage = DynAPI.getImage(imageSrc,this.defaultImage.w,this.defaultImage.h);
	if (!this.selected) this.change(this.defaultImage);
}


TreeButtonImage.prototype.changeSelectedImage=function(imageSrc) {
	this.selectedImage = DynAPI.getImage(imageSrc,this.selectedImage.w,this.selectedImage.h);
	if (this.selected) this.change(this.selectedImage);
}

TreeButtonImage.prototype.setSelected = function(b) {
    this.selected=b;
	if (this.selected) {
		this.change(this.selectedImage);
		this.invokeEvent("select");
	}
	else {
		this.change(this.defaultImage);
		this.invokeEvent("deselect");
	}
}

/** Change the icon shown in the node. **/
TreeButtonImage.prototype.setIcon = function(img) {
    if (typeof(image)=="string") img=DynAPI.getImage(img);
    this.icon=img;
	if (img && this.component.created) this.component.doc.images[this.component.id+"Icon"].src = img.src;
}

/** Temporarly change the image that is visible **/
TreeButtonImage.prototype.change = function(img) {
    if (typeof(image)=="string") img=DynAPI.getImage(img);
	if (img) this.component.doc.images[this.component.id+"Image"].src = img.src;
}
