// WidgetInterface
// adds DynLayer methods to all other widgets
// 2000.03.11

// Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

WidgetInterface = function() {}
WidgetInterface.prototype.getClass = function() {return this.constructor}
WidgetInterface.prototype.getComponent = function() {return this.component}
WidgetInterface.prototype.toString = function() {return this.getComponent().toString()+'.getParentComponent()'}

WidgetInterface.prototype.addChild = function(v) {this.getComponent().addChild(v)}
WidgetInterface.prototype.removeChild = function(v) {this.getComponent().removeChild(v)}
WidgetInterface.prototype.deleteChild = function(v) {this.getComponent().deleteChild(v)}
WidgetInterface.prototype.removeFromParent = function() {this.getComponent().removeFromParent()}
WidgetInterface.prototype.deleteFromParent = function() {this.getComponent().deleteFromParent()}

WidgetInterface.prototype.moveTo = function(x,y) {this.getComponent().moveTo(x,y)}
WidgetInterface.prototype.moveBy = function(x,y) {this.getComponent().moveBy(x,y)}
WidgetInterface.prototype.setX = function(v) {this.getComponent().setX(v)}
WidgetInterface.prototype.getX = function() {return this.getComponent().getX()}
WidgetInterface.prototype.setY = function(v) {this.getComponent().setY(v)}
WidgetInterface.prototype.getY = function() {return this.getComponent().getY()}
WidgetInterface.prototype.setPageX = function(v) {this.getComponent().setPageX(v)}
WidgetInterface.prototype.getPageX = function() {return this.getComponent().getPageX()}
WidgetInterface.prototype.setPageY = function(v) {this.getComponent().setPageY(v)}
WidgetInterface.prototype.getPageY = function() {return this.getComponent().getPageY()}

WidgetInterface.prototype.setSize = function(w,h) {this.getComponent().setSize(w,h)}
WidgetInterface.prototype.setWidth = function(v) {this.getComponent().setWidth(v)}
WidgetInterface.prototype.getWidth = function() {return this.getComponent().getWidth()}
WidgetInterface.prototype.setHeight = function(v) {this.getComponent().setHeight(v)}
WidgetInterface.prototype.getHeight = function() {return this.getComponent().getHeight()}
WidgetInterface.prototype.getContentWidth = function() {return this.getComponent().getContentWidth()}
WidgetInterface.prototype.getContentHeight = function() {return this.getComponent().getContentHeight()}

WidgetInterface.prototype.setStyle = function(v) {this.getComponent().setStyle(v)}
WidgetInterface.prototype.getStyle = function() {return this.getComponent().getStyle()}
WidgetInterface.prototype.setVisible = function(v) {this.getComponent().setVisible(v)}
WidgetInterface.prototype.getVisible = function() {return this.getComponent().getVisible()}
WidgetInterface.prototype.setZIndex = function(v) {this.getComponent().setZIndex(v)}
WidgetInterface.prototype.getZIndex = function() {return this.getComponent().getZIndex()}
WidgetInterface.prototype.setClip = function(v) {this.getComponent().setClip(v)}
WidgetInterface.prototype.getClip = function() {return this.getComponent().getClip()}

WidgetInterface.prototype.setBgImage = function(v) {this.getComponent().setBgImage(v)}
WidgetInterface.prototype.getBgImage = function() {return this.getComponent().getBgImage()}
WidgetInterface.prototype.setBgColor = function(v) {this.getComponent().setBgColor(v)}
WidgetInterface.prototype.getBgColor = function() {return this.getComponent().getBgColor()}
WidgetInterface.prototype.setHTML = function(v) {this.getComponent().setHTML(v)}
WidgetInterface.prototype.getHTML = function() {return this.getComponent().getHTML()}
WidgetInterface.prototype.getPadding=function() {return this.getComponent().pad;}
WidgetInterface.prototype.setPadding=function(p) {this.getComponent().setPadding(p);}

WidgetInterface.prototype.addEventListener = function(listener) {
	if (!this.eventListeners) this.eventListeners = []
	for (var i in this.eventListeners) {
		if (this.eventListeners[i]==listener) return
	}
	this.eventListeners[this.eventListeners.length] = listener
}
WidgetInterface.prototype.removeEventListener = function(listener) {
	this.eventListeners = DynAPI.removeFromArray(this.eventListeners, listener, false)
}
WidgetInterface.prototype.invokeEvent = function(type,e) {
	for (var i in this.eventListeners) {
		if (e) e.target = this.eventListeners[i].target
		else {
			e = new DynEvent(type,this)
			e.target = this.eventListeners[i].target
		}
		this.eventListeners[i].handleEvent(type,e)
	}
}


WidgetInterface.methods = [
"getClass",
"getComponent",
"toString",
"addChild",
"removeChild",
"deleteChild",
"removeFromParent",
"deleteFromParent",
"setStyle",
"getStyle",
"moveTo",
"setX",
"getX",
"setY",
"getY",
"setPageX",
"getPageX",
"setPageY",
"getPageY",
"setSize",
"setWidth",
"getWidth",
"setHeight",
"getHeight",
"getContentWidth",
"getContentHeight",
"setVisible",
"getVisible",
"setZIndex",
"getZIndex",
"setClip",
"getClip",
"setBgImage",
"getBgImage",
"setBgColor",
"getBgColor",
"setHTML",
"getHTML",
"addEventListener",
"removeEventListener",
"invokeEvent",
"setPadding",
"getPadding"
]

WidgetInterface.inherit = function(component) {
	var m = WidgetInterface.methods
	for (var i in m) {
		component.prototype[m[i]] = WidgetInterface.prototype[m[i]]
	}
}
