/*  wx_Popup version 1.1

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

/* wx_Popup version 1.0 */
function wx_Popup(pcaption,theme,x,y,w,h) {
	this.id = "wx_Popup"+(wx_Popup.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")
	
	this.moveTo(x||0,y||0)
	this.setSize(w||200,h||20)

	this.caption=pcaption||''

	this.setVisible(false)

	this.theme=theme||''

	this.items= new Array()
	this.ItemIndex = wx_Popup.Count
	this.Selected=null

	return this
}
wx_Popup.Count = 0;
wx_Popup.prototype = new DynLayer
wx_Popup.prototype.getSubClass = function() {return wx_Popup}
wx_Popup.prototype.ImageBottom='popup-bottom.gif'
wx_Popup.prototype.ImageNormal='popup-normal.gif'
wx_Popup.prototype.ImageSelected='popup-selected.gif'
wx_Popup.prototype.ImageTop='popup-top.gif'
wx_Popup.prototype.ImageSubArrow='popup-arrow.gif'
wx_Popup.prototype.Parent=null
wx_Popup.prototype.theme=''
wx_Popup.prototype.ChildActive=false
wx_Popup.prototype.Lock=false
wx_Popup.prototype.Font='default'
wx_Popup.prototype.xSpacing=5
wx_Popup.prototype.ySpacing=2
wx_Popup.prototype.OnShow = new Function()
wx_Popup.prototype.OnHide = new Function()
wx_Popup.prototype.onCreate = function() {
		this.z=0
		
		this.tlyr=new DynLayer()
		this.blyr=new DynLayer()
		this.pcap=new DynLayer()
		this.pcap.setHTML('<span class="default">'+this.caption+'</span>')
		this.pcap.moveTo(2,1)
		this.pcap.setSize(this.w-4,18)
		this.tlyr.setHTML('<img src="'+this.theme+this.ImageTop+'" width="'+this.w+'" height="20">')
		this.tlyr.moveTo(0,0)
		this.tlyr.setSize(this.w,20)
		this.tlyr.setVisible(true)
		this.blyr.setHTML('<img src="'+this.theme+this.ImageBottom+'" width="'+this.w+'" height="20">')
		this.blyr.moveTo(0,this.h-20)
		this.blyr.setSize(this.w,20)
		this.blyr.setVisible(true)

		this.addChild(this.tlyr)
		this.addChild(this.blyr)
		this.addChild(this.pcap)
	}
wx_Popup.prototype.add=function (varCaption,varURL) {
	var i=this.items.length

	this.items[i] = new wx_Popupitem()
	if ((varURL=='') && (varCaption=='')) {
		this.items[i].Active=false
		this.items[i].Hint=''
	} else {
		this.items[i].Active=true
		this.items[i].Hint=varURL
	}
	this.items[i].caption=varCaption
	this.items[i].ItemIndex=i
	this.items[i].theme=this.theme
	this.items[i].Parent=this
	this.items[i].moveTo(null,this.items.length*20)
	this.items[i].setSize(this.w,20)

	if (varURL!='' && varURL!=null) this.items[i].onClick=function() { location=varURL }

	this.addChild(this.items[i])
	this.setSize(null,(this.items.length+2)*20)

	return this.items[i]
}
wx_Popup.prototype.Pop=function(x,y) { 
	this.moveTo(x||this.x,y||this.y)
	this.setZIndex(0)
	this.setVisible(true)
	this.OnShow()
}
wx_Popup.prototype.Hide=function() {
	this.setVisible(false)
	this.z=0
	if (this.Parent!=null) this.Parent.ChildActive=false

	this.OnHide()
}
wx_Popup.prototype.Collapse=function(){ 
	for (var i=0; i<this.items.length; i+=1) if (this.items[i].SubMenu!=null) this.items[i].SubMenu.Hide()
}
wx_Popup.prototype.closeAll=function() {
	if (!this.Lock) {
		this.setVisible(false)
		this.z=0
	}
	if (this.Parent!=null) {
		this.Parent.ChildActive=false
		this.Parent.closeAll()
	}
}

/*  wx_popupitem version 1.0 */
function wx_Popupitem(w,h) {
	this.id = "wx_Popupitem"+(wx_Popupitem.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")

	this.target=this

	this.moveTo(0,0)
	this.setSize(this.w,this.h)
	this.setVisible(true)

	return this
}
wx_Popupitem.Count=0
wx_Popupitem.prototype=new DynLayer
wx_Popupitem.prototype.getSubClass = function() {return wx_Popupitem}
wx_Popupitem.prototype.caption=''
wx_Popupitem.prototype.Active=false
wx_Popupitem.prototype.lblCaption=''
wx_Popupitem.prototype.Font='default'
wx_Popupitem.prototype.ItemIndex=null
wx_Popupitem.prototype.Height=20
wx_Popupitem.prototype.Hint=''
wx_Popupitem.prototype.theme=''
wx_Popupitem.prototype.SubMenu=null
wx_Popupitem.prototype.onClick=function() { }
wx_Popupitem.prototype.onCreate=function() {
		this.setHTML('<img src="'+this.theme+this.Parent.ImageNormal+'" name="itm'+this.id+'" width='+this.w+' height='+this.h+' border=0 alt="'+this.Hint+'">')

		this.dlyrSub=new DynLayer()
		this.dlyrC=new DynLayer()
		this.clicklyr=new DynLayer()

		this.dlyrC.setHTML('<span class="default">'+this.caption+'</span>')
		this.dlyrC.moveTo(this.Parent.xSpacing,this.Parent.ySpacing)
		this.dlyrC.setSize(this.w-10,this.h-4)
		this.dlyrC.setVisible(true)
		this.clicklyr.moveTo(0,0)
		this.clicklyr.setSize(this.w,this.h)
		this.clicklyr.setVisible(true)

		this.addChild(this.dlyrC)
		this.addChild(this.clicklyr)

		if (this.SubMenu!=null) {
			this.dlyrSub.setHTML('<img src="'+this.theme+this.Parent.ImageSubArrow+'" width=16 height=16>')
			this.dlyrSub.moveTo(this.w-18,2)
			this.dlyrSub.setSize(16,16)
			this.dlyrSub.setVisible(true)
			this.addChild(this.dlyrSub)
		}

		this.events=new EventListener(this)
		this.events.onmousedown = function (e) {
			var me=e.getTarget()
			if (me.Active) {
				me.doc.images["itm"+me.id].src=me.theme+me.Parent.ImageSelected
				if (is.ie) {
					me.Parent.closeAll()
					me.onClick()
				}
			}
			if (me.Parent.Lock==false) me.Parent.Hide()
			e.setBubble(false)
		}
		this.events.onmouseup = function (e) {
			var me=e.getTarget()
			if (me.Active) {
				me.doc.images["itm"+me.id].src=me.theme+me.Parent.ImageNormal
				if (is.ns) {
					me.Parent.closeAll()
					me.onClick()
				}
			}
			e.setBubble(false)
		}
		this.events.onmouseover = function (e) {
			var me=e.getTarget()
			if (me.Parent.Selected!=null && me.Parent.items[me.Parent.Selected].SubMenu!=null) {
				me.Parent.items[me.Parent.Selected].SubMenu.Hide()
				me.Parent.items[me.Parent.Selected].doc.images["itm"+me.Parent.items[me.Parent.Selected].id].src=me.theme+me.Parent.ImageNormal;
			}
			me.Parent.Selected=me.ItemIndex
			if (me.Active) {
				window.status=me.Hint
				me.doc.images["itm"+me.id].src=me.theme+me.Parent.ImageSelected
				if (me.SubMenu!=null) {
					me.SubMenu.Parent=me.Parent
					var winW = DynAPI.document.w
					var winH = DynAPI.document.h
					if (me.Parent.x+me.Parent.w+me.SubMenu.w>winW) var posX=me.Parent.x-me.SubMenu.w+30
					else var posX=me.Parent.x+me.Parent.w-30
					var posY=me.Parent.y+me.y-20
					if (me.SubMenu.Height+posY>winH) var posY=winH-me.SubMenu.Height;
					me.Parent.ChildActive=true
					me.SubMenu.setZIndex(me.Parent.z+1)
					me.SubMenu.Pop(posX,posY)
				}
			}
			e.setBubble(false)
		}
		this.events.onmouseout = function(e) {
			var me=e.getTarget()
			if (me.SubMenu!=null) {
				if (!me.SubMenu.visible) {
					if (me.Parent.Selected==me.ItemIndex) me.Parent.Selected=null
					if (me.Active) me.doc.images["itm"+me.id].src=me.theme+me.Parent.ImageNormal
				}
			} else {
				if (me.Parent.Selected==me.ItemIndex) me.Parent.Selected=null
				if (me.Active) me.doc.images["itm"+me.id].src=me.theme+me.Parent.ImageNormal
			}
			e.setBubble(false)
		}
		this.clicklyr.addEventListener(this.events)
		this.setVisible(true)
	}




