/*  wx_treenode version 1.2

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_treenode(x,y,w,pcontents,theme) {
	this.id = "wx_treenode"+(wx_treenode.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")
	
	this.caption=pcontents||''
	this.theme=theme||''
	this.items=new Array
	
	this.moveTo(x||0,y||0)
	this.setSize(w||128,18)
	this.setVisible(false)

	this.parent=null

	this.rootNode=this
	this.isBaseNode=true
	
	return this
}
wx_treenode.Count=0
wx_treenode.prototype = new DynLayer
wx_treenode.prototype.expanded=false
wx_treenode.prototype.rootNode=null
wx_treenode.prototype.isBaseNode=true
wx_treenode.prototype.selected=null
wx_treenode.prototype.selectedColor='#0000c0'
wx_treenode.prototype.imgExpand='treenode-expand.gif'
wx_treenode.prototype.imgCollapse='treenode-collapse.gif'
wx_treenode.prototype.imgEmpty='empty.gif'
wx_treenode.prototype.getSubClass=function() { return wx_treenode }
wx_treenode.prototype.onDeselect=function() {}
wx_treenode.prototype.onSelect=function() {}
wx_treenode.prototype.onMouseOver=function() {}
wx_treenode.prototype.onMouseOut=function() {}
wx_treenode.prototype.onRepaint=function() {}
wx_treenode.prototype.setColor=function(col) { this.selectedColor=col }	
wx_treenode.prototype.onCreate=function() {
		var nodecont=''

		if (this.items.length>0) nodecont='<img src="'+this.theme+this.imgExpand+'" width=16 height=16 name="'+this.id+'sw">'
		else nodecont='<img src="'+this.theme+this.imgEmpty+'" width=16 height=16 name="'+this.id+'sw">'
		
		this.setHTML(nodecont)

		this.canvas=new DynLayer()
		this.canvas.moveTo(16,0)
		this.canvas.setSize(this.w-16,18)
		this.canvas.setHTML('<span class="default">'+this.caption+'</span>')

		this.levents=new DynLayer()
		this.levents.moveTo(0,0)
		this.levents.setSize(this.w,18)
		
		this.events=new EventListener(this)
		this.events.onmousedown=function(e) {
			me=e.getTarget()
			if (e.x<17 && me.items.length>0) {
				if (me.expanded) me.collapse(false)
				else me.expand(false)
				me.repaint()
			} else me.privOnSelect()
			e.setBubble(false)
		}
		this.events.onmouseover=function(e) {
			me=e.getTarget()
			me.canvas.setHTML('<span class="over">'+me.caption+'</span>')
			me.onMouseOver()
			e.setBubble(false)
		}
		this.events.onmouseout=function(e) {
			me=e.getTarget()
			me.canvas.setHTML('<span class="default">'+me.caption+'</span>')
			me.onMouseOut()
			e.setBubble(false)
		}
		this.events.ondblclick=function(e) {
			me=e.getTarget()
			if (e.x>16 && me.items.length>0) {
				if (me.expanded) me.collapse(false)
				else me.expand(false)
			}
			e.setBubble(false)
		}
		
		this.levents.addEventListener(this.events)
		
		for (var i=0; i<this.items.length;i++) this.addChild(this.items[i])

		this.addChild(this.canvas)
		this.addChild(this.levents)
		this.repaint()
	}
wx_treenode.prototype.add=function(caption){
		var i=this.items.length
		this.items[i]=new wx_treenode(18,18+(i*18),this.w-16,caption,this.theme)
		this.items[i].index=i
		this.items[i].setSize(this.w,18)
		this.items[i].setVisible(true)
		this.items[i].isBaseNode=false
		this.items[i].parent=this
		this.items[i].rootNode=this.rootNode
		this.items[i].setColor(this.selectedColor)

		return this.items[i]
	}
wx_treenode.prototype.expand=function(recursive) {
		var tmph=18
		for (var i=0;i<this.items.length;i++){
			if (recursive) this.items[i].expand(recursive)
			tmph+=this.items[i].h
		}
		this.expanded=true
		this.setSize(this.w,tmph)
		this.doc.images[this.id+"sw"].src = this.theme+this.imgCollapse
		this.rootNode.repaint()
	}
wx_treenode.prototype.collapse=function(recursive) {
		for (var i=0;i<this.items.length;i++) {
			if (recursive) this.items[i].collapse(recursive)
		}
		this.expanded=false
		this.setSize(this.w,18)
		this.doc.images[this.id+"sw"].src = this.theme+this.imgExpand
		this.rootNode.repaint()
	}
wx_treenode.prototype.repaint=function() {
		var tmph=18
		var tmpw=this.w
		var y=18
		for (var i=0; i<this.items.length; i++) {
			if (this.expanded) {
				this.items[i].moveTo(null,y)
				this.items[i].repaint()
				tmph+=this.items[i].h
				if (this.items[i].getPageX()+this.items[i].w>tmpw) tmpw=this.items[i].getPageX()+this.items[i].w
			}
			y+=this.items[i].h
		}
		this.setSize(tmpw,tmph)
		this.onRepaint()
	}
wx_treenode.prototype.privOnSelect=function() {
		var oldnode=null
		if (this.rootNode.selected!=null) {
			oldnode=this.rootNode.selected
			this.rootNode.selected.canvas.setBgColor(null)
			this.rootNode.selected.canvas.setHTML('<span class="default">'+this.rootNode.selected.caption+'</span>')
			this.rootNode.selected.onDeselect(this)
		}
		this.canvas.setHTML('<span class="selected">'+this.caption+'</span>')
		this.canvas.setBgColor(this.selectedColor)
		this.onSelect(oldnode)
		this.rootNode.selected=this
	}	