/*  wx_treeview version 1.1

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_treeview(x,y,w,h,caption,theme) {
	this.id = "wx_treeview"+(wx_treeview.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")

	this.theme=theme||''
		
	this.canvas=new DynLayer
	this.caption=new DynLayer
	this.nodecanvas=new DynLayer
	this.sliderV = new wx_slider(0,20,18,this.h-27,this.theme)
	
	this.items=new Array

	this.moveTo(x||0,y||0)
	this.setSize(w||128,h||256)
	this.setCaption(caption||'')
	this.setVisible(false)
	
	return this
}
wx_treeview.Count=0
wx_treeview.prototype = new DynLayer
wx_treeview.prototype.imgCaption='treeview-caption.gif'
wx_treeview.prototype.imgCanvas=null
wx_treeview.prototype.getSubClass=function() { return wx_treeview }
wx_treeview.prototype.wx_treeviewsetSize=DynLayer.prototype.setSize
wx_treeview.prototype.setSize=function(w,h) {
		this.caption.setSize(this.w,18)
		this.sliderV.setSize(null,this.h-27)
		this.canvas.setSize(this.w-2,this.h-22)
		this.nodecanvas.setSize(this.canvas.w,this.canvas.h)
		this.recalculate()
		this.wx_treeviewsetSize(w,h)
	}
wx_treeview.prototype.setCaption=function(cap) {
		this.lblCaption=cap
		this.caption.setHTML('<span class="default">'+this.lblCaption+'</span>')
	}
wx_treeview.prototype.setCanvas=function(src){ 
		this.imgCanvas=src 
		this.canvas.setBgImage(this.imgCanvas)
	}
wx_treeview.prototype.onCreate=function() {
		this.setHTML('<img src="'+this.theme+this.imgCaption+'" width="'+this.w+'">')

		this.caption.moveTo(2,2)
		this.canvas.moveTo(1,20)
		this.nodecanvas.moveTo(5,5)

		this.sliderV.moveTo(this.w-21,null)
		this.sliderV.setVertical(true)
		this.sliderV.setMax(this.canvas.h)
		this.sliderV.setVisible(true)
		this.sliderV.treeview=this
		this.sliderV.onChange=function() {
				this.treeview.nodecanvas.moveTo(null,5-(this.position*9))
			}
		
		this.addChild(this.caption)
		this.addChild(this.canvas)
		this.addChild(this.sliderV)
		
		for (var i=0;i<this.items.length; i++) this.nodecanvas.addChild(this.items[i])
		this.canvas.addChild(this.nodecanvas)
	}
wx_treeview.prototype.add=function(node) {
		var i=this.items.length
		this.items[i]=node
		this.items[i].treeview=this
		this.items[i].onRepaint=function() {
				this.treeview.nodecanvas.setSize(null,this.h)
				this.treeview.recalculate()
			}
		this.items[i].setVisible(true)
		this.items[i].moveTo(2,2)
	}
wx_treeview.prototype.recalculate=function() {
		if (this.nodecanvas.h>this.h-27) {
			this.sliderV.setMax(Math.round((this.nodecanvas.h-(this.h-27))/9)+1)
			this.sliderV.setPosition(this.sliderV.position)
		} else {
			this.sliderV.setPosition(0)
			this.sliderV.setMax(1)
		}
	}