/*  DynFunctions

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function DynFunctionsLibrary() { this.toString = function() { return "DynFunctions"} }
DynFunctions = new DynFunctionsLibrary()

/*---------------------------------------------------------------------------------------------
   DecToHex
   Decimal to Hex convertor.
   note:works only for 0-256
*/
DynFunctions.DecToHex=function(val){
	lo=val%16
	val-=lo
	lo+=48
	if (lo>57) lo+=7

	hi=val/16
	hi+=48
	if (hi>57) hi+=7

	return String.fromCharCode(hi,lo)
}

/*---------------------------------------------------------------------------------------------
   GetColor 
   Return a HTML valid color value.
   
   parameters:  
   	r - Red value of color
   	g - Green value of color
   	b - Blue value of color 
*/   	
DynFunctions.getColor=function(r,g,b) { return '#'+DynFunctions.DecToHex(r)+DynFunctions.DecToHex(g)+DynFunctions.DecToHex(b) }

/*---------------------------------------------------------------------------------------------
   createRedPal
   creates a palette of 256 red tints
   
   parameters:
   	pal - an array, will be filled with html valid color strings
*/
DynFunctions.createRedPal=function(pal){
	var r=g=b=0
	for (var i=0; i<256; i++){
		pal[i]=DynFunctions.getColor(r,g,b)
		r+=8
		if (r>255) { r=255; g+=6; b+=2}
		if (g>255) { g=255; b+=2 }
		if (b>255) { b=255 }
	}
}
/*---------------------------------------------------------------------------------------------
   createGrayPal
   creates a palette of 256 gray values
   
   parameters:
   	pal - an array, will be filled with html valid color strings
*/
DynFunctions.createGrayPal=function(pal){
	var r=0
	for (var i=0; i<256; i++){
		pal[i]=DynFunctions.getColor(r,r,r)
		r+=4
		if (r>255) { r=255 }
	}
}
/*---------------------------------------------------------------------------------------------
   createBluePal
   creates a palette of 256 blue tints
   
   parameters:
   	pal - an array, will be filled with html valid color strings
*/
DynFunctions.createBluePal=function(pal){
	var r=g=b=0
	for (var i=0; i<256; i++){
		pal[i]=DynFunctions.getColor(r,g,b)
		b+=6
		if (b>255) { b=255; g+=2 }
		if (g>255) { g=255; r+=2 }
	}
}
/*---------------------------------------------------------------------------------------------
   createGreenPal
   creates a palette of 256 green tints
   
   parameters:
   	pal - an array, will be filled with html valid color strings
*/
DynFunctions.createGreenPal=function(pal){
	var r=g=b=0
	for (var i=0; i<256; i++){
		pal[i]=DynFunctions.getColor(r,g,b)
		g+=6
		if (g>255) { g=255; b+=2 }
		if (b>255) { b=255; r+=2 }
	}
}
/*---------------------------------------------------------------------------------------------
   tPoint
   Can be used for 3D points.
   
   properties:
   	x - x position
   	y - y position
   	z - z position
*/
DynFunctions.tpoint=function() { return this }
DynFunctions.tpoint.prototype.x=0
DynFunctions.tpoint.prototype.y=0
DynFunctions.tpoint.prototype.z=0
/*---------------------------------------------------------------------------------------------
   sintable
   Generates a 360 degrees sintable
   
   parameters:
   	lsin - array that will contain the sin values
*/
DynFunctions.sintable=function(lsin){
	for (var i=0; i<361; i+=1) lsin[i]=Math.sin((i/180)*Math.PI)
}
/*---------------------------------------------------------------------------------------------
   costable
   Generates a 360 degrees costable
   
   parameters:
   	lcos - array that will contain the cos values
*/
DynFunctions.costable=function(lcos){
	for (var i=0; i<361; i+=1) lcos[i]=Math.cos((i/180)*Math.PI)
}