<?

/*

Dan's PHP Library (DPLib) v0.2

Copyright (C) 2000 Dan Steinman
Distributed under the terms of the GNU General Public License

dan@dansteinman.com
www.dansteinman.com

*/

### PHP to JavaScript Functions

function js_printString($jsName,$phpString) {
	$phpString = ereg_replace("\n","\\n",$phpString);
	$phpString = ereg_replace("'","\'",$phpString);
	$phpString = ereg_replace('"','\"',$phpString);
	print "$jsName = '$phpString';\n";
}


### HTML/XML Parsing Functions

// formats a string with html for easier parsing
function html_formatTags($html) {
	$html = ereg_replace("( +)"," ",$html);
	$html = ereg_replace("( *)=( *)","=",$html);
	$html = ereg_replace("( *)>","> ",$html);
	$html = ereg_replace("<( *)","\n <",$html);
	$html = ereg_replace("</( *)"," </",$html);

	$html = ereg_replace("'","\"",$html);

	$chunks = split(" ",$html);
	$html = "";
	for ($i=0;$i<count($chunks);$i++) {
		$chunk = $chunks[$i];
		if (ereg("<\/",$chunk)) {
			$lchunk = strtolower($chunk);
			$html .= "$lchunk ";
		}
		else if (ereg("<",$chunk)) {
			$lchunk = strtolower($chunk);
			$html .= "$lchunk ";
		}
		else if (ereg("=",$chunk)) {
			if (ereg("=\"",$chunk) && !ereg("\"(.*)\"",$chunk)) {
				$html .= "$chunk ";
				continue;
			}
			$tmp = split("=",$chunk,2);
			$name = strtolower($tmp[0]); // lowercase the attribute
			$name = ltrim($name);
			$value = $tmp[1]; // dont lowercase the value
			
			if (ereg("\"(.*)\"",$value)) $html .= $name."=".$value." ";
			else if (ereg(">",$value)) {
				$value = ereg_replace(">","\">",$value);
				$html .= $name."=\"".$value." ";
			}
			else $html .= $name."=\"".$value."\" ";
		}
		else {
			$html .= "$chunk ";
		}
	}
	$html = ereg_replace("( +)"," ",$html);
	$html = ereg_replace("> ",">\n",$html);
	$html = ereg_replace("\n( *)<","\n<",$html);
	$html = ereg_replace("\n\n\n","\n",$html);
	$html = ereg_replace("\n\n","\n",$html);
	return $html;
}

function html_parseTagInnerText($tag) {
	$f = strpos($tag,'>')+2;
	$l = strrpos($tag,'<')-2;
	$value = substr($tag, $f, $l-$f+1);
	return $value;
}

// returns array of all the attributes of a single html tag
// requires formatted tags
function html_parseTagAttributes($tag) {
	$html = ereg_replace("(.*)<","",$tag); // strip outter text
	$html = ereg_replace(">(.*)","",$tag); // strip inner text
	
	$attributes = array();

	$realchunks = array();
	$lookingforend = false;
	
	$chunks = split(" ",$html);
	
	for ($i=1;$i<count($chunks);$i++) {  // skip first "<tag" chunk
		$chunk = $chunks[$i];
		if ($lookingforend) {
			if (ereg("=",$chunk)) {
				$lookingforend = false;
			}
			else {
				$last = count($realchunks)-1;
				$realchunks[$last] .= "$chunk";
				
				if (ereg("=\"(.*)\"",$realchunks[$last]) ) {  // found last piece: value"
					$lookingforend = false;
				}
				else {
					$realchunks[$last] .= " ";
				}
				continue;
			}
		}
		if (ereg("=",$chunk)) {
			$realchunks[] = "$chunk";
			
			if (!ereg("=\"(.*)\"",$chunk)) {  // is not complete: "value
				$last = count($realchunks)-1;
				$realchunks[$last] .= " ";
				$lookingforend = true;
			}
		}
		else {
			// extraneous attribute with no value eg. <table nowrap>
			$realchunks[] .= "$chunk=\"\"";
		}
	}
	
	for ($i=0;$i<count($realchunks);$i++) {
		$chunk = $realchunks[$i];
		$chunk = ereg_replace("\"","",$chunk); // strip quotes
		$parts = split("=",$chunk,2);
		$name = $parts[0];
		$value = $parts[1];
		//$value = ereg_replace("&","&amp;amp;",$value);
		
		/*
		if (count($parts)>2) { // google weird value
			for ($j=2;$j<count($parts);$j++) {
				$value .= "=".$parts[$j];
			}
		}*/	
		$attributes[$name] = $value;
	}
	
	return $attributes;
}

// parse out the forms and all their data from the page and return as an array
// requires formatted tags

// FIX SELECT,TEXTAREA,RADIO

function html_isolateTags($tagname,$html,$closingtag) {
	$taglist = split("\n",$html);
	$tags = array();
	$intag = false;
	for ($i=0;$i<count($taglist);$i++) {
		$tag = $taglist[$i];
		
		if (!$intag && ereg('<'.$tagname,$tag) && !ereg('</'.$tagname.'>',$tag)) {
			$tags[] .= $tag."\n";
			$intag = true;
		}
		else if ($intag) {
			if (ereg('</'.$tagname.'>',$tag)) {
				$tags[count($tags)-1] .= $tag."\n";
				$intag = false;
			}
			else if (!$closingtag && ereg('<',$tag)) {
				$tags[count($tags)-1] .= "</$tagname>\n";
				$intag = false;
				$i -= 1;
			}
			else {
				$tags[count($tags)-1] .= $tag."\n";
			}
		}		
	}
	return $tags;
}

function html_fixAction($action,$url) {
	if (substr($action,0,7) != "http://") {
		$server = eregi_replace("http://","",$url);
		if (ereg("/",$server)) {
			$server = substr($server,0,strrpos($server,"/"));
		}
		$a = $action;
		$action = "http://".$server;
		if ($a[0]!="/") $action .= "/";
		$action .= $a;
	}
	return $action;
}

function html_parseForms($html) {
	$forms = html_isolateTags("form",$html,true);
	$formar = array();
	
	for ($i=0;$i<count($forms);$i++) {
		$form = $forms[$i];
		$att = html_parseTagAttributes($form);
		$action = $att["action"];
		$method = $att["method"];
		if ($method=="") $method = "get";
		
		if ($action) {
			$formar[] = array(
				"action" => $action,
				"method" => $method,
				"inputs" => array()
			);
		}
		else continue;
		
		$textareatags = html_isolateTags("textarea",$form,true);
		for ($j=0;$j<count($textareatags);$j++) {
			$att = html_parseTagAttributes($textareatags[$j]);
			if ($att["name"]) {
				$value = html_parseTagInnerText($textareatags[$j]);
				$formar[count($formar)-1]["inputs"][] = array($att["name"],"textarea",$value);
			}
		}
		
		$selecttags = html_isolateTags("select",$form,true);
		for ($j=0;$j<count($selecttags);$j++) {
			$selectatt = html_parseTagAttributes($selecttags[$j]);
			$optiontags = html_isolateTags("option",$selecttags[$j],false);
			
			if ($selectatt["name"] && count($optiontags)>0) {
				$optionatt = html_parseTagAttributes($optiontags[0]);
				$formar[count($formar)-1]["inputs"][] = array($selectatt["name"],"select",$optionatt["value"]);
			}
		}
		
		$inputtags = html_isolateTags("input",$form,false);
		for ($j=0;$j<count($inputtags);$j++) {
			$att = html_parseTagAttributes($inputtags[$j]);
			if ($att["name"]) {
				$formar[count($formar)-1]["inputs"][] = array($att["name"],$att["type"],$att["value"]);
			}
		}
		
	}

	return $formar;
}

function html_getPrintableHTML($string) {
	$string = ereg_replace("&","&amp;",$string);
	$string = ereg_replace("<","&lt;",$string);
	$string = ereg_replace("<","&lt;",$string);
	$string = ereg_replace(" ","&nbsp;",$string);
	return $string;
}
function html_printHTML($string) {
	$phtml = html_getPrintableHTML($string);
	print $phtml;
}

### Socket Functions

function http_get($url) {
	$lines = http_fetch($url,false,80,'');
	return implode($lines,"\n");
}
function http_post($url) {
	$lines = http_fetch($url,true,80,'');
	return implode($lines,"\n");
}
function http_getFromProxy($url,$port,$proxy) {
	$lines = http_fetch($url,false,$port,$proxy);
	return implode($lines,"\n");
}
function http_getAsArray($url) {
	return http_fetch($url,false,80,'');
}

// return content of a url as a string array
function http_fetch($url,$post,$port,$proxy) {
	if ($post) $type = "POST";
	else $type = "GET";
	
	$server = ereg_replace("http://","",$url);	
	$file = strstr($server,"/");
	if ($file) $server = ereg_replace("$file","",$server);
	else {
		$file = "/";
	}
	/*print "URL = $url\n";
	print "SERVER = $server\n";
	print "FILE = $file\n";*/
	
	if ($proxy) $fp = fsockopen($proxy, $proxy_port, &$errno, &$errstr);
	else $fp = fsockopen($server, $port, &$errno, &$errstr);
	
	if ($fp) {
		fputs($fp,"$type $file HTTP/1.0\nHost: $server\n\n");
		$lines = array();
		while ($line = fgets($fp, 4096)) {
			$lines[] = $line;
		}
		fclose($fp);
	}
	if (count($lines)==0 || !$fp) {  // try fopen()
		$fp = fopen($url, "r");
		if ($fp) {
			$lines = array();
			while ($line = fgets($fp, 4096)) {
				$lines[] = $line;
			}
			fclose($fp);
		}
	}
	return $lines;
}


### Cookie Functions

class CookieSet {
	var $data = array();
	var $expires = null;
	var $name = "";
	var $retvalue = "";
	
	function CookieSet($name) {
		$this->name = $name;
	}
	function addData($name,$value) {
		$this->data[$name] = $value;
	}
	function setExpires($expires) {
		$this->expires = time()+$expires;
	}
	function save() {
		$name = "CookieSet_".$this->name;
		$value = $this->encode();
		if ($this->expires!=null) SetCookie($name,$value,$this->expires);
		else SetCookie($name,$value);
	}
	function delete() {
		$this->data = array();
		$this->expires = 0;
		$this->retvalue = "";
		$this->save();
	}
	function encode() {
		$this->retvalue = '';
		$c = count($this->data);
		$i = 0;
		while(list($name,$value) = each($this->data)) {
			$v = urlencode($value);
			$this->retvalue .= $name.'='.$v;
			if ($i++ < $c-1) $this->retvalue .= '&';
		}
		return $this->retvalue;
	}
	function decode() {
		$cs = split('&',urldecode($this->retvalue));

		for ($j=0;$j<count($cs);$j++) {
			$parts = split('=',$cs[$j]);
			$cname = $parts[0];
			$cvalue = urldecode($parts[1]);
			$this->addData($cname,$cvalue);
		}
	}
}
function http_getCookieSet($name) {
	$c = http_getCookies();
	for ($i=0;$i<count($c);$i++) {
		if ($c['CookieSet_'.$name]) {
			$cookieset = new CookieSet($name);
			$cookieset->retvalue = $c['CookieSet_'.$name];
			$cookieset->decode();
			return $cookieset;
		}
	}
	return false;
}

function http_getCookies() {
	global $HTTP_COOKIE;
	
	$cookies = array();

	$c = split('; ',$HTTP_COOKIE);	
	for ($i=0;$i<count($c);$i++) {
		$parts = split('=',$c[$i]);
		$name = $parts[0];
		$value = $parts[1];
		$cookies[$name] = $value;
	}
	return $cookies;
}

### Array Functions

// note: these are not necessary if you use PHP 4.0

// returns the index of a value
function ar_indexOf($array,$val) {
	for ($i=0;$i<count($array);$i++) {
		if ($array[$i] == $val) {
			return $i;
		}
	}
	return -1;
}

// removes the element of the given index
function ar_remove($array,$index) {
	$temp = array();
	for ($i=0;$i<$index;$i++) {
		$temp[$i] = $array[$i];
	}
	for ($i=$index;$i<count($array)-1;$i++) {
		$temp[$i] = $array[$i+1];
	}
	return $temp;
}

// inserts the element into the given index
function ar_insert($array,$index,$val) {
	$temp = array();
	for ($i=0;$i<$index;$i++) {
		$temp[$i] = $array[$i];
	}
	$temp[$index] = $val;
	for ($i=$index+1;$i<count($array)+1;$i++) {
		$temp[$i] = $array[$i-1];
	}
	return $temp;
}

// replaces the element of the given $index with the new $val sent
function ar_replace($array,$index,$val) {
	$l = count($array);
	$array = ar_removeAt($array,$l);
	$array = ar_insertAt($array,$l,$val);
	return $array;
}

// removes the last element
function ar_pop($array) {
	return ar_remove($array,count($array)-1);
}
// pop an element of the beginning of array and returns the new array
function ar_shift($array) {
	return ar_remove($array,0);
}

// inserts as the last element
function ar_push($array,$val) {
	$array[] = $val;
	return $array;
}

// push one or more elements onto the beginning of array and returns the new array
function ar_unshift($array,$val) {
	return ar_insert($array,0,$val);
}


// prints all the values separated by \n
function ar_printValues($array) {
	ar_printValuesWith($array,"\n");
}

// prints all the values separated a given separator
function ar_printValuesWith($array,$sep) {
	for ($i=0;$i<count($array);$i++) {
		echo "$array[$i]";
		echo "$sep";
	}
}

### Generic Utility Functions

function debug($error) {
	print "<body bgcolor=white><br clear=all><b>Error:</b> <i>$error</i>";
	die();
}


### Database Wrapper

// note: it really only does MySQL -- anyone want to do others?

class MySQLDatabase {
	var $host = "";
	var $username = "";
	var $password = "";
	var $database = "";
	
	var $connected = false;
	
	function setDB($host,$user,$pass) {
		$this->setHost($host);
		$this->setUsername($user);
		$this->setPassword($pass);
	}
	
	function setHost($host) {
		$this->host = $host;
	}
	function setUsername($username) {
		$this->username = $username;
	}
	function setPassword($password) {
		$this->password = $password;
	}
	function setPort($port) {
		$this->port = $port;
	}
	
	function connect() {
		$this->link = mysql_connect($this->host,$this->username,$this->password);
		if ($this->link) {
			$this->connected = true;
			return $this->link;
		}
		else {
			debug("unable to connect to database");
		}
	}

	function select_db($database) {
		$this->database = $database;
		if (!$this->connected) $this->connect();
		if (mysql_select_db($database,$this->link)) return true;
		else {
			debug("could not select database $database");
		}
	}

	function query($query) {
		return mysql_query($query,$this->link);
	}
	function num_rows($result) {
		return mysql_num_rows($result);
	}
	function fetch_array($result) {
		return mysql_fetch_array($result);
	}
	function fetch_row($result) {
		return mysql_fetch_row($result);
	}
	
	function checkPassword($username, $password, $table) {
		if ($table==null) $table = "users";
		$result = mysql_query("select * from $table where(username='$username' && password=password('$password'))");
		if ($result && $this->num_rows($result)==1) return true;
		else return false;
	}

	function tableExists($table) {
		$result = $this->query("select * from $table");
		if ($result) return true;
		else return false;
	}

}
