<?

/*

PEngines No-User example

The regular PEngines script is a user-based system to be incorporated in my MyPortal
project, so that different users can have different search fields.

However the following example can be used on a regular website where a user-based system
is not needed.  You must create 1 user using the dplib-login.php3 script, and create the search
engine entries needed with the regular pengines.php3 script.  Then use this script so that
you can put your custom search engine front-end into your website.  This is exactly what I did
for the demo on http://www.dansteinman.com/php/pengines/pengines-demo.php3

*/

include('dplib.php3');  // Dan's PHP Library
include('class.pengines.php3');  // PEngines Class

// -- DPLib: make a database connection ------------

$mysql = new MySQLDatabase;
$mysql->setDB('localhost','myuser','mypass');
$mysql->select_db('myportal');

/********************************
********************************/

// manually set these variables to the same as the dplib account that you created

$username = "guest";
$password = "guest";

/********************************
********************************/

if ($mysql->checkPassword($username,$password,null)) {
	$t = time()+100*24*60*60;
	SetCookie("cusername",$username,$t);
	SetCookie("cpassword",$password,$t);
}
else die("Error: bad username password");

// -- PEngines ------------

$engines = new PEngines($mysql);

// -- PEngines: custom default page ------------

// if no command print a custom default page with links to auto-submit and edit the engine forms

	// returns array with all the saved form data needed
	$forms = $engines->getSavedForms();
		
	// this is a javascript function to submit the hidden form
	print '	
	<script language="JavaScript">

	PEngines = {
		search : function() {
			var p = document["pengines"]
			var f = document[p.which.options[p.which.selectedIndex].value]
			f[this.queryFields[f.name]].value = p.query.value
			f.submit()
		},
		queryFields : new Array()
	}
	';
	
	for ($i=0;$i<count($forms);$i++) {
		$formname = $forms[$i]['formname'];
		$queryfield = $forms[$i]['queryfield'];
		
		print "PEngines.queryFields['$formname'] = '$queryfield';\n";
	}
	
	print "</script>
	<h3>Welcome $username</h3>
	<p><a href=#>Edit engines</a> (disabled for demo)
	<br><a href=#>Make a new engine</a> (disabled for demo)
	<p>Here is your custom universal search engine:<br>
	";
	
	if (!count($forms)) {
		print "no engines available";
	}
	else {
		print '<form name="pengines" onSubmit="PEngines.search(); return false;">
		<select name="which">';
		
		// loop through each form
		for ($i=0;$i<count($forms);$i++) {
	
			$engine = $forms[$i]['engine'];  // the name of the engine
			$formname = $forms[$i]['formname'];  // the name of the form to submit
			$queryfield = $forms[$i]['queryfield'];
			
			print "<option value=\"$formname\">$engine</option>";
		}
		
		print '</select>
		<input type=text name=query size=20>
		<input type=submit value="Search">
		</form>
		';
		
		// print hidden forms to the page for submitting
		print $engines->getHiddenFormsString();
	}

?>
